struct srcdestinfo
   {
   unsigned int datatype;
   unsigned int eabyte;
   unsigned int mod;
   union
      {
      UNSIGNED_LONG word;
      struct
         {
         unsigned char low;
         unsigned char high;
         unsigned char low2;
         unsigned char high2;
         } byte;
      } value;
   };

/* allowable values of datatype are: */
#define FARPTR 100  /* SEG:OFS */
  /* DATA16 - 16-bit data */
  /* DATA8 - 8-bit data (may be sign-extended) */
  /* REG - 16-bit register, AX through DI */
  /* SEGREG - CS, ES, SS, DS */
#define MEMREF 101  /* needs EA byte, or is AL .. BH */

/* allowable values of mod are:
     0   (0 << 6)
     64  (1 << 6)
     128 (2 << 6)
     192 (3 << 6)  */

/* allowable values of eabyte are:
  mod==192 && WORD      mod==192 && BYTE       mod!=192
       AX=0                  AL=0           addressing mode
       CX=1                  CL=1
       DX=2                  DL=2
       BX=3                  BL=3
       SP=4                  AH=4
       BP=5                  CH=5
       SI=6                  DH=6
       DI=7                  BH=7
       ES=8
       CS=9
       SS=10
       DS=11  */



/*
   Flags for assembly.  This says how to handle this assembly case.
*/
#define A_AADAAM 1
#define A_MATH 2
#define A_CALLJMP 3
#define A_FARCALL 4
#define A_INCDEC 5
#define A_MULDIV 6
#define A_INOUT 7
#define A_INT 8
#define A_JMPSHRT 9
#define A_LOADER 10
#define A_MOV 11
#define A_PUSHPOP 12
#define A_ROTSHF 13
#define A_RET 14
#define A_XCHG 15
#define A_ENTER 16
#define A_DB 17
#define A_UNDEF 18  /* for things I can't assemble */

struct asminfo
   {
   unsigned char firstbyte;
   unsigned int flags;
   unsigned int eabase;
   unsigned int reg;
   };

struct sameas
   {
   char name[8];
   unsigned int code;
   };
