/*
   This file is copyright (c) 1986 by William Couture.  All rights reserved.
*/


/*
   VIM stands for VIrtual Machine.  It is a program that interprets
   8088 code.  Currently the only major piece missing is the assembler. 
   (NOTE: to see how I implemented the disassembler, and see how to use
   the optables to implement the assembler, see the 8086 & 8088
   microprocessor instant reference card from Micro Logic Corp.,
   P.O.B. 174, Dept C, Hackensack, NJ 07602 (201)342-6518)

   The compiler used is the DeSmet compiler, V2.51, for the IBM-PC.
   The program was originally intended for the Microsoft C compiler, V3.0,
   or perhaps the Aztec C compiler, as I thought that a large memory
   model would be needed.  The DeSmet compiler was used as a syntax
   checker, and when testing started I began using DeSmet specific functions
   to implement the test functions, and in the way of all good things,
   the program has grown around the test functions.  However, things seem
   to be going smoothly, and I will keep my fingers crossed.
   A note to the non-DeSmet users:  The DeSmet puts() routine DOES NOT
   append a newline, '\n', to all strings.  This is very nice, but
   not standard.  If you move this to another compiler, things will not
   come out on the line they are supposed to until you write a replacement
   for puts() that does not add the newline.

   Several pieces of code (particularly the register union declaration)
   assume that the machine running this uses low-byte-first data storage.
   I have tried to avoid other machine dependencies, but I'm afraid that
   some may have crept in.  Among the things that seem to be assumed
   everywhere:
   a char is an unsigned byte, or can at least be cast unsigned.
   an int (particularily an unsigned int) is a 2 byte quantity.
   a long is a 4 byte quantity that can be cast or treated as unsigned
      (i.e. can be manipulated bitwise).

   If you are going to move this to another compiler, make sure that the
   type conversion rules followed by your compiler match those of the
   DeSmet compiler, or the source will need to be changed.  For example,
   statements such as longint += bytevar; are used, where both are
   unsigned (e.g. if bytevar=0xff, it is not sign extended when added
   to longint).  Where sign extensions are needed, I have tried to implement
   them in a compiler independent fashion.

   For more information, see the comments in the individual files.  Comments
   may be a bit spotty, but I think I have the major points noted, and
   there are some really weird things happening down deep in both the
   chip and simulator that are interesting.

   For speed freaks:  Most time is spent in the routine checkaddress().
   See the comments for this routine if you want to speed things up.

   Although doing virtual memory simulation, this program was written on
   a PC clone (a Zenith), and still bears traces of its origin.  The
   DOS limit of 640K is buildt into the program in the checkaddress()
   routine.  If you want to run a 704K DOS space, or move this to another
   machine, you will have to modify this routine.
*/

/*
   The above comments are, unfortunately, out of date.  The VIM program is
   now very machine specific to a PC (or XT or AT ...) or clone.  This is
   done to allow the simulator at the hardware of the machine it is running
   on.

   One thing that should be constantly watched is that adding variables or
   strings to the source should be done in such a way that variables such
   as REGS or DEST or SOURCE or REG or MOD or RM or ... (i.e. the important
   variables) land on word addresses.  This makes for a faster program on
   a AT or AT-clone.  The batch file MAKELIST and the program DATALIST
   make this easy to do.  The easiest way to keep things aligned is to add
   or remove the space between the 1986 and 1987 in the copyright notice.
*/
