/*
   This file is copyright (c) 1988 by William Couture.  All rights reserved.
*/


#include <compiler.h>
#include <vim.h>
#include <opdefs.h>

#define SPACE ' '

extern unsigned int memok;  /* Check memory addresses.  Included so
                               that it can be reset to TRUE. */

extern unsigned char dumpblank[80];  /* Defined in TEST.C.  A "blank line" to
                                         be filled in with the dump data */
extern unsigned char nl_str[2];

extern void (*checkaddress)();

void dump(startseg,startofs,lng,flag)
   unsigned int startseg,startofs,lng,flag;
       /* Note:  Width is included as a standard dump takes up the entire
          width of the screen, which is not nice in a windowing environment.
          (That's a hint for someone who wants to build a better interface
          for this program.)
        */
   {
   unsigned int i,j,tempseg,tempofs,holdofs,tempseg2,tempofs2;
   unsigned int byte,mask,addrmask,charofs;
   unsigned char segstr[6],ofsstr[6],buf[181],ch[5];
   UNSIGNED_LONG count,length,maxlen;

   length = (UNSIGNED_LONG)lng;
   if (flag == BYTE)
      maxlen = length-1;
   else
      {
      length += length;
      maxlen = length-2;
      }
   mask = 0x000f;  /* Mask for tempofs.  This pulls out the low nibble,
                      thus giving 16 bytes (0-15) per dump line. */
   addrmask = 0xfff0;  /* Mask for address, to give starting dump
                          address as xxx0 in all cases */
   charofs = 61;  /* Number of characters into the blank line to start
                     entering the ASCII characters of the dump */
   strcpy(buf,dumpblank);  /* Start off with a blank buffer. */
   if (flag == WORD)
      buf[33] = '-';
   count = 0;
   hexword(&startseg,segstr);  /* Only need to find segment string once */
   while (count <= length)
      {
      tempseg2 =
      tempseg = startseg;  /* Use tempseg and tempofs as they will be changed
                              by the checkaddress function. */
      tempofs = startofs+count;
      tempofs2 = tempofs+1;
      i = tempofs & mask;  /* Offset of this byte into the blank line */
      j = i+i+i;  /* Offset * 3, as 2 hex digits plus space is 3 total */
      (*checkaddress)(&tempseg,&tempofs);  /* translate to virtual memory */
      memok = TRUE;  /* I don't care if this is a protected address */
      if (flag == BYTE)
         {
         byte = PEEK(tempseg,tempofs);
         hexbyte(&byte,ch);
         buf[11+j] = ch[0];  /* 11 = width of seg:ofs and spaces */
         buf[12+j] = ch[1];
         if ((byte >= SPACE) && (byte < '\177'))  /* If displayable ASCII */
            buf[charofs+i] = byte;
         else
            buf[charofs+i] = '.';  /* else a period (standard) */
         }
      else
         {
/*         byte = PEEK(tempseg,tempofs) + (PEEK(tempseg,tempofs+1) << 8); */
         (*checkaddress)(&tempseg2,&tempofs2);
         memok = TRUE;
         byte = PEEK(tempseg,tempofs) + (PEEK(tempseg2,tempofs2) << 8);
         hexword(&byte,ch);
         buf[11+j] = ch[0];
         buf[12+j] = ch[1];
         buf[13+j] = ch[2];
         buf[14+j] = ch[3];
         }
      i = ((flag == BYTE) ? (i+1):(i+2));
      if ((i > mask) || (count > maxlen))  /* if end of line or end of
                                                   dump */
         {
         tempofs = (startofs+count) & addrmask;
                                      /* paragraph boundary for offset */
         hexword(&tempofs,ofsstr);
         for (i = 0; i < 4; i++)  /* put segstr, ofsstr into blank space */
            {
            buf[i] = segstr[i];
            buf[i+5] = ofsstr[i];
            }
         PUTS(buf);  /* output line */
         PUTS(nl_str);  /* and cr/lf (DeSmet does not automatically add, thank
                         goodness!) */
         strcpy(buf,dumpblank);
         if (flag == WORD)
            buf[33] = '-';
         if (gchar() == ESC_KEY)  /* if ESC, stop dumping */
            count = length;
         }
      count = ((flag == BYTE) ? (count+1):(count+2));  /* count this byte */
      }
   }
