/*
   This file is copyright (c) 1986 by William Couture.  All rights reserved.
*/


/*
   This text was moved from the file VIM.C to here to shorten the working
   length of VIM.C.
*/


/*
   Figure out the location of the Program Segment Prefix, and set up data
   area for the interrupt handler routines.  The way this works is that
   the DeSmet V2.4 (and 2.51) startup code goes like this:

   CS:0000    JMP xxxx       ;always a 3 byte jump to initalization routines
                             ;
                             ;immediately afterwards is the main() routine
                             ;IF main() IS THE FIRST FUNCTION IN VIM.C!
                             ;
   CS:0003    PUSH BP        ;main() is just another routine to C, so save the
                             ;stack frame upon entry
   CS:0004    MOV BP,SP      ;set up new frame to access locals
   CS:0006    SUB SP,+04     ;allocate locals on stack.  4 bytes = 2 unsigned
                             ;ints for THIS PARTICULAR main()
                             ;NOTE THE SIGN EXTENSION IN THIS SUBTRACTION.
                             ;IF A LARGE NUMBER OF LOCAL VARIABLES
                             ;(>127 BYTES) ARE BEING ALLOCATED, IT WILL BE
                             ;A 4 BYTE INSTRUCTION INSTEAD!
   CS:0009    NOP            ;The NOP's inserted via the #asm above
   .
   .                         ;program code goes here
   .
   CS:xxxx-1  RET            ;end of program code
   CS:xxxx    SS:            ;start of initalization routines
   CS:xxxx+1  MOV [yyyy],DS  ;save DS=segment address of PSP for internal use
                             ;(actual address of DS save area is offset bytes
                             ;3 and 4 from the SS: segment override.)
   .
   .                         ;continue initilization code
   .
   In order to have interrupt call routines in this program, it is
   necessary to point the vectors to the desired functions.  Morever,
   IN ORDER TO AFFECT PROGRAM VARIABLES, IT IS NECESSARY TO KNOW THE
   DATA SEGMENT! Since DS is unknown at the entry to the interrupt
   handling routine, the only information that is certain is the code
   segment (in the small memory model, there is only 1 code segment).

   Thus, it is necessary to recover DS knowing only CS.  Defining the NOP's
   above, and AFTER THEY HAVE EXECUTED replacing them with the program's
   DS gives a known location that can be referenced to recover the data
   segment.

   The other NOP's will be used by the interrupt routines themselves as
   a data area for use in CALLing the old interrupt routine.  Each
   interrupt routine has its OWN 4 byte area so that multiple
   interrupts at once will not blow each other away.

   NOTE THE NECESSITY OF THE SMALL MEMORY MODEL FOR THESE STATEMENTS!
   If a large memory model is used, upon entry to the interrupt handling
   routines it is not known that the current CS is the CS in which the
   value of DS is stored, or even that a stored DS will properly address
   the programs data.

   There may be a way around these problems, but I can't think of one
   currently.  If I do come up with one, I may move VIM to a large
   model if the user shell forces it.  However, as a large memory model
   would force long calls to routines (taking more time), this is a
   last resort.  (Perhaps the FAR ptr option in MSC V3 would be appropriate?
   Hmmm....)



   Next, the first "pspaddr =" statement finds the destination of the jump
   instruction (the +3 is for the instruction length).

   The second "pspaddr =" gets the save address of the PSP segment register
   (the +3 and +4 are the offsets from the start of the segment override
   prefix.)

   The last "pspaddr =" gets the actual value of the PSP segment.  A note for
   the observant:  The initalization code also sets DS to SS (small memory
   model puts the stack in the same segment as the data), so the fetch of
   the PSP segment is valid from the DS segment.  Also, the SS register is
   not available via DeSmet C function.

   This is a HORRIBLE routine.  It is ugly and totally non-transportable.
   However, it is the only method I know of to do the job.
*/
