/*
   This file is copyright (c) 1988 by William Couture.  All rights reserved.
*/


/*
   The help file.  This can be useful.
*/

#include <compiler.h>  /* needed for VIM.H */
#include <vim.h>  /* contains HELPSIZE definition */



char *helptext[HELPSIZE] = {
"  In the following command summary, [] (square brackets) denote an optional\n",
"  parameter, and {} (curly brackets) mean pick one of the enclosed.  Do not\n",
"  type either the square brackets or the curly brackets.\n\n",
"  All numbers must be hexadecimal (hex), and may consist of expressions\n",
"  with hex numbers (the digits 0-9 and the letters A-F), the names of the\n",
"  16-bit registers (AX, BX, CX, DX, SI, DI, BP, SP, DS, ES, SS, CS, IP or PC),\n",
"  and the following operators (in order of lowest precedence to highest):\n",
"  XOR: ^   OR: |   AND: &   Rotate Left: <   Rotate Right: >   Subtraction: -\n",
"  Addition: +   Modulo (MOD): %   Division: /   Multiplication: *   NOT: ~\n",
"  Parenthesis (), square brackets [], and curly brackets {} can also be used,\n",
"  brackets can contain ofs or seg:ofs, and mean a word fetch (square brackets)\n",
"  or byte fetch (curly brackets).  Any letters (hex constants or register\n",
"  names) can be in upper or lower case, and the expression must not contain\n",
"  any spaces.\n\n",
"  Strings are surrounded by either matched double quotes (\") or matched single\n",
"  quotes (\').\n\n",
"  Use ESC to Break commands like T, D, U, W, etc.",
"*;\n",
"- A line beginning with a semi-colon is a comment, and is ignored.\n\n",
" A [[seg:]ofs]\n",
"- Start the Assembler.  All 8088 instructions and 80286 real-mode instructions\n",
"- are recognized.  To avoid confusion with addressing modes, hex and register\n",
"- expressions are not allowed, only hex constants.\n\n",
" B [seg1:]ofs1[,endofs1][=count1]...[[seg10:]ofs10[,endofs10][=count2]]\n",
"- Set sticky breakpoints.  Sticky breakpoints are not discarded when control\n",
"- returns to VMDEBUG.  There is a limit of 10 sticky breakpoints, and 20\n",
"- total breakpoints.  Entering a new set of sticky breakpoints clears the old\n",
"- set. The default segment is the CS at the time the command was issued.\n\n",
" B\n",
"- Toggle active status of sticky breakpoints.  This allows you to turn them\n",
"- off without clearning them.  If there are no sticky breakpoints, having them\n",
"- on does nothing.\n\n",
"*BL\n",
"- List the current sticky breakpoints.\n\n",
" BO\n",
"- Turn sticky breakpoints OFF.  This command clears sticky breakpoints.\n\n",
" C filename\n",
"- Create filename on disk.  The length is in the BX:CX register pair, and the\n",
"- the memory to write starts at CS:IP.  Any previous file contents are lost.\n",
"- This command could be called Write, but then what would I call Where?\n\n",
" C [seg:]ofs drive sector number\n",
"- Write the specified memory (default seg is DS) to sectors on disk (drive A=0,\n",
"- B=1, etc).  NOTE: SECTOR SIZE IS ASSUMED TO BE 512 BYTES!\n\n",
" D [[seg:]ofs [{ofs2 Llength}]]\n",
"- Dump memory in BYTE (ASCII) format.  The default segment is the last dump\n",
"- segment, or DS after a ZD command.  The default length is 80H (128 decimal)\n",
"- bytes.  Use ESC to stop the dump.\n\n",
"*DS [number]\n",
"- Dump stack in WORD format, with top-of-stack closest to the next command\n",
"- prompt. (i.e. The top-of-stack is at the \"bottom,\" like the actual stack.)\n",
"- The default is to dump 8 words, or the number can be specified.  Use ESC to\n",
"- stop the dump.\n\n",
" DW [[seg:]ofs [{ofs2 Llength}]]\n",
"- As D above, but dump in WORD format.  The default length is 40H (64 decimal)\n",
"- words.\n\n",
" E [seg:]ofs {byte1 string1} [{byte2 string2} ...]\n",
"- Enter values into memory, for the length of the given values.  The default\n",
"- segment is DS.\n\n",
" F [seg:]ofs {ofs2 Llength} {byte1 string1} [{byte2 string2} ...]\n",
"- Fill the specified memory range with the given values, repeating the values\n",
"- as necessary.  The default segment is DS.\n\n",
"*G [=[CS:]IP] [[seg1:]ofs1[,endofs1][=cnt1]...[seg20:]ofs20[,endofs20][=cnt20]]\n",
"- Start executing program at current or given CS:IP, with up to 20 breakpoints\n",
"- on memory ranges.  The default segment for breakpoints is CS, the range is 1\n",
"- byte if endofs is not given, and the count of \'hits\' until the break occurs\n",
"- defaults to 1.  If sticky breakpoints are used, the number of breakpoints\n",
"- will be decreased so that there are only 20 total breakpoints.\n\n",
" H [name]\n",
"- Help, optionally on a specific command or all commands staring with name.\n",
"- ? is another name for help.  For example, \'H R\' shows the register command,\n",
"- while \'H EX\' shows the examples.\n\n",
" I portnumber\n",
"- Get the value from the port and display it.\n\n",
" L\n",
"- Load the file specified by the N command.  If the file is not an .EXE file,\n",
"- it is loaded at the current CS:IP.\n\n",
"*L [seg:]ofs drive sector number\n",
"- Read the specified disk sectors (drive A=0, B=1, etc) to memory (default seg\n",
"- is DS).  NOTE: SECTOR SIZE IS ASSUMED TO BE 512 BYTES!\n\n",
" M expression\n",
"- Evaluate and show the result of a mathematical expression.\n\n",
" N filename\n",
"- Set the pathname and filename to load.  This is not copied into the PSP.\n\n",
" O portnumber value\n",
"- Output the value to the specified port.\n\n",
" P [=[CS:]IP] [[seg1:]ofs1[,endofs1][=cnt1]...[seg19:]ofs19[,endofs19][=cnt19]]\n",
"- As G above, but a breakpoint is automatically placed on the instruction after\n",
"- the current instruction.\n\n",
" Q\n",
"- Quit VMDEBUG and return to DOS.\n\n",
"*R [regname [value]]\n",
"- The default is to display all registers and the current instruction.  If a\n",
"- register name is given, the new value can be on the command line, or you\n",
"- will be prompted for a new value.  The register name can be any of the 16-\n",
"- bit registers (AX, BX, CX, DX, SI, DI, BP, SP, DS, ES, SS, CS, IP or PC),\n",
"- or F (the Flag register).  The flag names and the abbreviations used are:\n",
"- Overflow, Direction, Interrupt, Trap, Sign, Zero, Aux Carry, Parity, Carry\n",
"- with ON abbreviations of: OV, DN, EI, TR, NG, ZR, AC, PE, CY\n",
"- and OFF abbreviations of: NV, UP, DI, NT, PL, NZ, NA, PO, NC\n\n",
" S [seg:]ofs {ofs2 Llength} {byte1 string1} [{byte2 string2} ...]\n",
"- Search the specified memory for a byte pattern.  The default segment is DS.\n\n",
" T [=[CS:]IP] [number]\n",
"- Trace program, starting at the current or given CS:IP.  The default is to\n",
"- trace 1 step, or the number may be specified.  Interrupts, breakpoints, and\n",
"- Break-On-I/O are turned off for this command.  Use ESC to stop the trace.",
"*U [[seg:]ofs [{ofs2 Llength}]]\n",
"- Unassemble memory.  The default segment is the last Unassemble segment, or\n",
"- CS after a ZD command, and the default length is 20H (32 decimal) bytes.\n",
"- Use ESC to stop the disassembly.\n\n",
" V\n",
"- View the virtual screen, if screen swapping is enabled.  Pressing any key\n",
"- will restore the VMDEBUG screen.\n\n",
" W [number]\n",
"- Where was I?  VMDEBUG can remember and display the last 2047 (7FFH) machine\n",
"- instructions that were executed.  The default is to display the last 16 (10H)\n",
"- instructions, or the number can be specified.  The Where queue is reset by\n",
"- the L, ZL, and ZD commands, and by setting CS or IP.  Use ESC to stop.\n\n",
"*X [=[CS:]IP] [T] [Qnumber] [N{insttype \"instruction string\"}]\n",
"-         [[seg1:]ofs1[,endofs1][=count1]...[seg20:]ofs20[,endofs20][=count20]]\n",
"- eXecute program from the current or given CS:IP.  This is like the G\n",
"- command, but more breakpoint options are available.  They are:\n\n",
"- T - eXecute in trace mode, showing registers and instruction at every step.\n",
"-  When in trace mode, the ESC key, not the hotkey, returns to VMDEBUG.\n\n",
"- Qnumber - Quit after a specified number of instructions have been executed.\n\n",
"- N{insttype \"instruction string\"} - Quit on instruction type (e.g. ADD, MOV,\n",
"-  IRET, etc.) or when an instruction that matches \"instruction string\" is\n",
"-  decoded.  (e.g. \"MOV AX\" or \"INC WORD PTR [SI+0ADC\" or ...)\n\n",
"*Z7\n",
"- Toggle 8087 WAIT instruction between a NOP (default) and a breakpoint.\n\n",
" ZB [port1] ... [port20]\n",
"- Toggle Break-on-I/O status.  The I/O instructions are IN, OUT, INSB, INSW,\n",
"- OUTSB, and OUTSW.  The new status is displayed.  If a list of ports is\n",
"- given, Break-on-I/O is set ON for those ports only.\n\n",
" ZC\n",
"- Toggle PC-Clone status.  When enabled, access to the I/O ports is allowed.\n",
"- The new status is displayed.  PC-Clone status is enabled by the ZD command.\n\n",
" ZD [commandline]\n",
"- Load a virtual memory copy of DOS from the real DOS, and set up the PSP\n",
"- fields from the command line, if given.  The program is set to an INT 20\n",
"- instruction (terminate program).  PC-CLONE (see the ZC command) status is\n",
"- enabled, and the current state of the screen is saved for screen swapping.\n",
"- This command can be used any time a fresh start is desired.\n\n",
"*ZE [E [num_seq num_crt num_attrib num_graphics]]\n",
"- Toggle EGA/VGA screen swapping.  The new status is displayed.  This is for\n",
"- boards that emulate CGA/MDA at the hardware level, so that EGA/VGA screen\n",
"- swapping will not be used when it is not appropriate.  Use the ZE command\n",
"- before the ZD command, as saving the EGA/VGA screen state uses mode swapping.\n",
"- The E parameter and register counts are for Extended EGA/VGA screen swapping.\n",
"- See the manual for details.\n\n",
" ZF [filename]\n",
"- Enter showfile screen.  The specified file is displayed on a text screen.\n",
"- If no name is given, the last file used is re-displayed.\n",
"- Use ZG to see what files are available.\n\n",
" ZG [filespec]\n",
"- Get a directory, optionally with a path and/or a wildcard filename.\n\n",
" ZH number\n",
"- Set the hotkey (used to interrupt VMDEBUG during a G, P, or X command) to\n",
"- Right-Shift and hotkey, where number is the SCANCODE of the hotkey.  The\n",
"- default hotkey is Right-Shift and ESC (scancode = 1).  Some suggestions\n",
"- for hotkeys are 0E (backspace), 1C (return), and 39 (spacebar).\n",
"*ZI [name]\n",
"- Redirect input to come from the file or device given by name.  If no name\n",
"- is given, input comes from CON (the keyboard).  Pressing ESC will return\n",
"- input to CON, as will a blank line in the input file.  This redirection is\n",
"- invisible to the virtual DOS loaded by the ZD command.\n",
"- At the start of VMDEBUG, the current directory is checked for a file named\n",
"- VMDEBUG.CFG.  If found, it is used by the ZI logic to configure VMDEBUG.\n\n",
" ZK\n",
"- Toggle passing of the keyboard int. into VMDEBUG.  Default is to pass it.\n",
"- This allows you to isolate the program under test from accidental keystrokes.\n\n",
" ZL\n",
"- Load the saved state of the virtual machine from the file specified by the\n",
"- ZN command.  This allows you to continue a debugging session later, or to\n",
"- start a debugging session from a known state several times.\n\n",
"*ZM [seg]\n",
"- Display the size of virtual memory and the unused RAM mapping.  Optionally,\n",
"- the 64K segment for unused memory may be set to seg (C000, D000, E000, or\n",
"- F000).  This mapping allows you to avoid conflicts with memory mapped\n",
"- devices or buffers in your machine.\n\n",
" ZN imagename\n",
"- Set the filename for the save/restore of the virtual machine.  See the ZW\n",
"- and ZL commands.\n\n",
" ZO [name]\n",
"- Echo output to the file or device given by name.  If no name is given or\n",
"- the name is CON, any previous ZO command is canceled.  If the file already\n",
"- exists, the output is appended to the old file.  This echoing is invisible\n",
"- to the virtual DOS loaded by the ZD command.  This command allows you to\n",
"- save a record of your debugging session.\n\n",
"*ZP seg1:ofs1 [seg2:ofs2] ... [seg20:ofs20]\n",
"- Patch the current memory image at the specified seg:ofs locations for\n",
"- pre-DOS 3.0 or incompatible memory mappings (such as the HP VECTRA),\n",
"- and re-apply the patch at every ZD command.  See the manual for details.\n\n",
" ZR\n",
"- Show the current contents of the video display registers.  These values are\n",
"- the actual register contents, not the saved BIOS values, and include the\n",
"- contents of the write-only registers.\n\n",
" ZS\n",
"- Toggle screen swapping (screen is swapped for G, P, and X (without T)\n",
"- program execution).  The new status is displayed.  When enabled, screen\n",
"- swapping gives VMDEBUG its text-mode debugging screen, while the application\n",
"- may do anything it desires, including custom reprogramming of the video\n",
"- hardware.  This allows VMDEBUG and the application to share the video display\n",
"- without worrying about video mode or over-writing needed information.\n\n",
"*ZT [number [irqnumber]]\n",
"- Set the current clock (or IRQ) divisor to number+1.  Using number=FFFF will\n",
"- turn off the interrupt passed by VMDEBUG to programs.  If no numbers are\n",
"- given, the current divisors are displayed.  The default clock divisor is 7D0H\n",
"- (2000 decimal) for a PC, and 1F4H (500 decimal) for an AT, and all IRQ\n",
"- divisors default to 0 (no division).  Legal IRQ numbers are 02H through 0FH.\n\n",
" ZU\n",
"- Toggle the final destination of IRQs not passed into VMDEBUG between passing\n",
"- them to the system or internal handling within VMDEBUG (the default).\n\n",
" ZV [number]\n",
"- Toggle extended (1 second long) video retrace mode.  This allows programs\n",
"- that try to do everything during retrace time to finish.  If a number is\n",
"- given, the retrace length is set to number clock ticks (18 ticks = 1 second).\n\n",
"*ZW\n",
"- Save the current state of the virtual machine in the file specified by\n",
"- the ZN command.  This allows you to continue debugging later, or to have\n",
"- several debugging sessions with the same initial conditions.\n\n",
" ZY\n",
"- Toggle re-mapping of DMA to and from re-mapped ROMs during the ZZ command.\n",
"- The default is not to re-map DMA, so that re-mapped ROMs are safe from disk\n",
"- reads (to ROM) but cannot be written to disk by DMA running under VMDEBUG.\n\n",
" ZZ [file1 [seg1 [file2 [seg2 [file3 [seg3 [file4 [seg4 [commandline]]]]]]]]]\n",
"- Replace the 64K ROM segments at C000, D000, E000, and/or F000 (the default\n",
"- segment is F000) with the specified files.  If no names are given, the\n",
"- original ROMs are restored.  In any case, the mapping of DMA and unused\n",
"- memory is not changed.  This command also performs a ZD command.\n",
"- DO NOT USE THIS COMMAND UNLESS YOU KNOW WHAT YOU ARE DOING!\n\n",
"*EXAMPLE VMDEBUG SESSION #1:\n\n C>vmdebug   -> start VMDEBUG\n VMDEBUG version 1.32A ...\n",
"- >zd     -> load a copy of DOS local to VMDEBUG\n >g      -> start executing DOS\n",
"- C>      -> after a moment or two, the DOS prompt running under VMDEBUG\n",
"-         -> now, use the hotkey (Right-Shift plus ESC) to return to VMDEBUG\n",
"- Number of instructions executed: 0001:0E79   -> shows how far we have gone\n",
"- AX=037B ...\n >w      -> see where we have been\n 0185:157E  32E4       XOR    ",
"- AH,AH\n ...\n >g      -> continue running DOS\n   dir   -> get a directory\n ...\n",
"*EXAMPLE VMDEBUG SESSION #2:\n\n C>vmdebug   -> start VMDEBUG\n VMDEBUG version 1.32A ...\n",
"- >zd     -> load a copy of DOS local to VMDEBUG\n >n myprog.exe   -> program to be",
"- loaded\n >l      -> load it\n >g ds:1234   -> stop when byte at DS:1234 is",
"- referenced\n Number of instructions executed: 0000:ABCD\n AX=0201 ...\n",
"- 0EEF:1573  A13312       MOV     AX,[1233]                 2317:1233=0400\n",
"-         -> high byte of word is our breakpoint\n >g ss:sp+4   -> stop on a",
"- stack reference\n Number of instructions executed: 0000:005A\n AX=0741 ...\n",
"- 0EEF:159C  1F           POP     DS   -> DS is at our stack location\n >g",
"- 0:21*4=2   -> stop at the 2nd reference to the INT 21H vector\n Number of",
"- instructions executed: 0000:0509\n AX=4001 ...\n 0EEF:6827  CD21         INT",
"-     21\n >p      -> skip over this DOS call\n ...\n\n"
};


int nextpage()
   {
   int keyin;

   while ((keyin = gchar()) < 255)  /* clear queue before getting char */
      ;
   PUTS("\n\nPress any key to continue, ESC to end.\n");
   while ((keyin = gchar()) > 255)
      ;
   if (keyin != ESC_KEY)
      clrscr(24);
   return(keyin);
   }

curpos(row,col)
   {
#asm
   push bp
   mov bp,sp           ;AZTEC C specific:  frame pointer not set up!
   mov bh,0            ;page 0
   mov dh,byte ptr [bp+4]  ;get row
   mov dl,byte ptr [bp+6]  ;get col
   mov ah,2            ;fn = set cursor position
   int 10h             ;call BIOS
   pop bp              ;AZTEC C specific:  frame pointer not cleaned up!
#endasm
   }

clrscr(maxrow)
   int maxrow;
   {
#asm
   push bp
   mov bp,sp           ;AZTEC C specific:  frame pointer not set up!
   mov ax,0600h  ;scroll up entire window
   mov cx,0      ;from 0,0
   mov dl,4fh    ;max col is 80
   mov dh,byte ptr [bp+4] ;max row is passed
   mov bh,7      ;attribute for fill
   int 10h       ;call BIOS
   pop bp              ;AZTEC C specific:  frame pointer not cleaned up!
;
;  a nop to align code for greater speed
;
   nop           ;code alignment byte
#endasm
   }
