/*
   This file is copyright (c) 1988 by William Couture.  All rights reserved.
*/


/*
   MOREVIM.C contains routines that do not fit comfortably into the VIM.C
   program due to the size of the source file.  The procedures in here will
   NOT be changing frequently/at all.
*/
#include <compiler.h>
#include <vim.h>
#include <opdefs.h>
#include <regstruc.h>
#include <machine.h>
#include <include\ctype.h>

#define NUMOPS 11
unsigned char operatorstr[12] = "^|&<>-+%/*~";

#define RIGHT_BRACE '}'
#define LEFT_BRACE '{'

unsigned int fromhex_pos, num_paren, num_square, num_curly;
UNSIGNED_LONG fromhex_temp;

unsigned int dta_ofs, dta_seg;


extern union regunion regs;

extern struct intrptr int8ptr,int9ptr,intaptr,intbptr,intcptr,intdptr,inteptr,
                            intfptr,
    int70ptr,int71ptr,int72ptr,int73ptr,int74ptr,int75ptr,int76ptr,int77ptr,
    ctrlcptr;

extern unsigned int pspaddr;  /* location of VIM's PSP */
extern unsigned int segoffset;  /* All these are defined in VIM.C */
extern unsigned int rom_offset;
extern unsigned int pcscreen;
extern unsigned int pclone;
extern unsigned int numbreaks;
extern unsigned int cmdptr;
extern unsigned int memok;
extern unsigned int clockcount;
extern unsigned int clockdivide;
extern unsigned int hwintflag;
extern unsigned int hwintnumber;
extern unsigned int hwintstack[8];  /* queue of pending interrupts */
extern unsigned char port60queue[64];
extern unsigned int port60ptr;
extern unsigned int hotkeypressed;
extern unsigned int rshiftstatus;
extern unsigned int rshiftused;
extern unsigned int hkscancode;
extern unsigned int codesegment;
extern unsigned int datasegment;
extern unsigned int maxpara;
extern unsigned int videobase;
extern unsigned int feature_addr;
extern unsigned int hercules;
extern int egascreen;
extern int vgascreen;  /* say that VGA is installed */
extern unsigned int attribflipflop;
extern unsigned int mdap3b8;
extern unsigned int mdap3bf;
extern unsigned int cgap3d8;
extern unsigned int cgap3d9;
extern unsigned int patchseg[21];
extern unsigned int patchofs[21];
extern unsigned int patchbyte[21];
extern unsigned int patched;
extern unsigned int outfile;
extern unsigned int fileinput;
extern unsigned int asmspacing;
extern unsigned int valid;

extern unsigned int zf_file;  /* file number for ZF command */
extern UNSIGNED_LONG zf_pos;
extern unsigned char zf_screen[1850];  /* 1840 plus slop */
extern char zf_header[];

extern unsigned char screen[12290];
extern unsigned char vga_norm_dac[768];
extern unsigned char vga_virt_dac[768];
extern unsigned char mdanorm[NUM_CRT_REG];
extern unsigned char mdaregs[NUM_CRT_REG];
extern unsigned char mdamode[18];
extern unsigned char cganorm[NUM_CRT_REG];
extern unsigned char cgaregs[NUM_CRT_REG];
extern unsigned char cgamode[18];
/*  extern unsigned char egamode[2][64]; */
extern unsigned char sinorm[NUM_SI_REG];
extern unsigned char siregs[NUM_SI_REG];
extern unsigned char attribnorm[NUM_ATTRIB_REG];
extern unsigned char attribregs[NUM_ATTRIB_REG];
extern unsigned char seqnorm[NUM_SEQ_REG];
extern unsigned char seqregs[NUM_SEQ_REG];
extern unsigned char mdaports[8];
extern unsigned char cgaports[6];
extern unsigned char egaports[28];

extern unsigned int seq_reg_count;
extern unsigned int si_reg_count;
extern unsigned int attrib_reg_count;
extern unsigned int crt_reg_count;
extern unsigned int extended_swap;

extern unsigned char cmdline[150];
extern unsigned char globalstr[150];
extern unsigned char tempstr[150];
extern unsigned char err_str[10];
extern unsigned char err_num[10];
extern unsigned char err_fn[12];
extern unsigned char err_rng[10];
extern unsigned char nl_str[2];
extern unsigned char space_str[2];
extern unsigned char filename[65];
extern char regnames[23][3];
extern char flagnames[2][9][3];
extern unsigned int flagmasks[9];
extern unsigned char outfilename[150];
extern unsigned char infilename[150];

extern char tab[2];

extern void (*checkaddress)();
extern void (*checkwaddress)();
extern UNSIGNED_LONG min_screen,max_screen;
extern struct addrtrap brkpoints[21];
extern unsigned int brkcounts[21];
extern unsigned int memmap[16];

#ifdef ZENITH
extern unsigned char scratchmem[16386];
#endif

void setvideoregs(),setegamode(),swapscreens(),saveegachrs(),swapegachrs();
void getvgaregs(),out2bports(), get_dac_regs(), set_dac_regs(), set_attr_reg();
void oops(),load_exe(),load_com(),display_flags();
char *hexword();


unsigned int wpeek(seg,ofs)  /* peek a WORD address */
   unsigned int seg,ofs;
   {
   return( PEEK(seg,ofs) + (PEEK(seg,ofs+1) << 8) );
   }

char *strupr(str)
   char *str;
   {
   int i;

   i = -1;
   while (str[++i])
      str[i] = toupper(str[i]);
   return(str);
   }

void startdos()
/*
   If enough virtual memory available, copy system memory from 0:0 to
   pspaddr:100 to virtual memory, adjust the DOS allocation chain at
   pspaddr-1:0 to show size of virtual memory, and adjust memory size at
   0:0410 and 0:413-414 in the BIOS data area.  Also, copy the scratchpad
   RAM (16K) at F000:0000 to an internal scratchpad buffer (for the Zenith,
   which this program was developed on).

   Adjust the memory size at pspaddr:2-3, and set the head settling time
   and motor start time in the DPT pointed to by Int 0x1e to 0.

   Set the 6845 registers to their default values.

   Then, put a CD20 at virtual pspaddr:100, set CS=DS=SS=ES=pspaddr,
   set IP to 0x100, set SP to 0xfffe, zero 0xfffe-0xffff, and set the
   interrupt flag.  This simulates a trivial .COM program that quits to
   DOS, and should leave the simulator running DOS.  Then, you may load
   .EXE programs, or whatever.

   In this routine, rather than calling (*checkaddress)() all the time, I
   will simply be adding segoffset.  This is legal because I know I will
   be working in existing memory, and I do not care about memory trapping.
   If a major change is made to (*checkaddress)(), you will want to review
   this function to make sure it conforms to the new virtual mapping!

   Note:  When I mark things as DeSmet specific, I am referring to the
   inline assembly language, not the memory addressing.
*/
   {
   unsigned int virtualseg,toseg,toofs,fromseg,fromofs,memavail,temp,i;
   UNSIGNED_LONG input_place;
   void (*func)();  /* declare a pointer to a function.  I prefer to reference
                       things through this pointer than directly through
                       the function name. */
   void ctrlchdlr();  /* declare function so we can set a pointer to it. */
   void setmchnvectors(),resetmchnvectors();

/*   temp = pspaddr;  make a working copy
   if (pspaddr & 0x003f)  check lower 6 bits of PSP segment
      temp += 0x0040;  */

   /* disable interrupts while vectors are being changed */
#asm
   cli    ;NO INTERUPTS!  INLINE ASSEMBLER IS COMPILER SPECIFIC!
#endasm
   resetmchnvectors(&ctrlcptr,0x8c);
/* IMPORTANT: Turn interrupts back on */
#asm
   sti   ;Interrupts OK now.  INLINE ASSEMBLER IS COMPILER SPECIFIC!
#endasm
   toseg = segoffset + rom_offset;  /* This is where virtual memory begins */
   toofs = 0;
   fromseg = 0;
   fromofs = 0;
   if (outfile)  /* if echoed output, make it invisible to virtual DOS */
      {
#asm
   mov bx,word ptr outfile_  ;get the handle to close
   mov ah,3eh            ;function = close
   int 21h               ;call DOS
#endasm
      }
   if (fileinput)
      {
#asm
   mov bx,word ptr fileinput_  ;get the file handle
   push bx                 ;save it
   xor cx,cx               ;high word of move offset is 0
   mov dx,cx               ;as is low word
   mov ax,4201h            ;move to current plus offset
   int 21h                 ;call DOS
   mov word ptr [bp-20],ax ;save low word of offset
   mov word ptr [bp-18],dx ;save high word of offset
   pop bx                  ;get handle again
   mov ah,3eh              ;fn = close
   int 21h                 ;call DOS
#endasm
      }
   while ((fromseg <= pspaddr) && (fromseg < maxpara))
                  /* copy everything possible */
      {
#asm
   cli   ;BEWARE OF INTERRUPTS DURING LONG MOVES!
         ;since I don't know the internal workings, beware of a repeated
         ;string move with segment override prefix!
         ;Also note that inline assembler is compiler specific!
#endasm
      MEMCPY(0x8000,fromseg,fromofs,toseg,toofs);  /* 32768 bytes */
#asm
   sti   ;Allow interrupts again. INLINE ASSEMBLER IS DeSmet SPECIFIC!
#endasm
      fromseg += 0x0800;  /* move to next 32K */
      toseg += 0x0800;
      }
    if (outfile)  /* if we need to restore echoed output for VIM */
      {
#asm
   mov dx,offset outfilename_   ;name of file to open
   mov ax,3d02h                 ;open for read/write
   int 21h                      ;call DOS
                  ; Note: Since the file was open previously, I will trust
                  ;  that it can be opened again without error.
   mov bx,ax                    ;set file handle
   mov word ptr outfile_,ax         ;save handle for later, just to be safe
                                ;(i.e. do not assume handle is the same as
                                ;before)
   mov dx,0                     ;low word = 0 for LSEEK
   mov cx,dx                    ;high word is also 0
   mov ax,4202h                 ;seek to EOF + 0
   int 21h                      ;call DOS
#endasm
      }
   if (fileinput)
      {
#asm
   mov dx,offset infilename_    ;name of file to open
   mov ax,3d00h                 ;open for read
   int 21h                      ;call DOS
                  ; Note: Since the file was open previously, I will trust
                  ;  that it can be opened again without error.
   mov bx,ax                    ;save handle
   mov word ptr fileinput_,ax   ;save handle for later, just to be safe
                                ;(i.e. do not assume handle is the same as
                                ;before)
   mov cx,word ptr [bp-18]      ;get high word of seek distance
   mov dx,word ptr [bp-20]      ;low word
   mov ax,4200h                 ;seek to BOF+offset
   int 21h                      ;call DOS
#endasm
      }
   ;  /* a null statement so that AZTEC will properly pick up the next
         asm statement */
#asm
   cli   ;No interrupts while this move is made!
#endasm
   if (videobase < 0x3d0)  /* this is a mono computer */
      MEMCPY(0x1000,0xb000,0x0000,datasegment,screen);
                     /* note the implicit small memory model */
   else
      MEMCPY(0x1000,0xb800,0x0000,datasegment,screen);
                        /* note the implicit small memory model */
#asm
   sti   ;Interrupts are OK again
#endasm
/*   memavail = maxpara >> 6;  change max paragraphs to K's */
   memavail = wpeek(0,0x413) - ((segoffset + rom_offset) >> 6);
   POKE( (memavail & 0xff),segoffset+rom_offset,0x413);  /* low byte */
   POKE( ((memavail >> 8) & 0xff),segoffset+rom_offset,0x414);  /* high byte */
   temp = PEEK(0,0x410);  /* get "switches" */
   if (memavail < 256)  /* if not a full set of system memory */
      {
      temp &= 0xf3;  /* mask out memory bits */
      if (memavail < 192)
         {
         if (memavail < 128)  /* I know I have to have 64K */
            temp |= 0x00;
         else
            temp |= 0x04;  /* set 128K */
         }
      else
         temp |= 0x80;  /* set 192K */
      }
   POKE(temp,segoffset+rom_offset,0x410);  /* set virtual system board memory */
   setvideoregs();  /* set up for screen swapping */
   if ((egascreen > 0) || (vgascreen > 0))
      saveegachrs();  /* if EGA or VGA, save the charset */
   pclone = TRUE;  /* allow DOS to access the screen and hardware! */
   regs.r.flag |= INTERRUPT;  /* allow interrupts */
   regs.r.flag &= TRAPOFF;  /* and turn off trap */

#ifdef ZENITH

#asm
   cli   ;NO INTERRUPTS DURING THE MOVE!  Inline assembler is
         ;compiler specific!
#endasm
   MEMCPY(0x4000,0xf000,0x0000,datasegment,&scratchmem[1]);
   /* Note the implicit small memory model in using a single data segment!
            This copies the 16K scratchpad RAM to it's own private area. */
#asm
   sti   ;Interrupts are OK again.  Inline assembler is compiler specific!
#endasm
   /* Once again, that whole thing is DeSmet specific */

#endif

   if (maxpara >= pspaddr + 4096)  /* if enough memory + 64K */
        /* if system memory is greater than virtual memory PSP segment,
           plus a workspace of 64K, then go ahead and interpret DOS */
      {
      temp = wpeek(pspaddr-1,3);
           /* Get the space from here to end of memory (left that way
              from the start of the program, as it does NOT deallocate
              unused memory). */
      temp -= segoffset+rom_offset;  /* Segoffset is already the number of paragraphs */
      virtualseg = segoffset + rom_offset + pspaddr;
      POKE( (temp & 0xff),virtualseg-1,3);  /* into virtual memory */
      POKE( ((temp >> 8) & 0xff),virtualseg-1,4);
      temp = wpeek(pspaddr,2);  /* get the current memtop from the PSP */
      temp -= segoffset+rom_offset;
      POKE( (temp & 0xff),virtualseg,2); /* adjust memtop in psp */
      POKE( ((temp >> 8) & 0xff),virtualseg,3);
      fromseg = wpeek(0,0x7a);  /* get Int 0x1e ptr */
      fromofs = wpeek(0,0x78);
      putbyte(fromseg,fromofs+9,0);  /* head settling time = 0ms */
      putbyte(fromseg,fromofs+10,0);  /* motor start time = 0 */
      if (patched)
         for (i = 1; i <= patched; i++)
            putbyte(patchseg[i],patchofs[i],patchbyte[i]);
      i = strlen(cmdline) - cmdptr;
      i = (i > 126 ? 126:i);
      cmdline[i+cmdptr] = '\015';  /* terminate command line for DOS */
      cmdline[i+cmdptr+1] = '\0';  /* and for C as well */
      POKE(i,virtualseg,0x80);
      i = cmdptr;
      do
         {
         POKE(cmdline[i],virtualseg,0x81+i-cmdptr);
         i++;
         } while (cmdline[i-1] != '\015');
      if (cmdline[cmdptr] != '\015')
         {
#asm
   push es                  ;save ES
   mov es,word ptr [bp-2]   ;virtualseg
   mov di,5ch               ;FCB1
   mov si,offset cmdline_   ;cmdline address
   add si,word ptr cmdptr_  ;plus offset into line
   mov ax,2901h             ;function 29, parsing = 1
   int 21h                  ;call DOS
   cmp byte ptr [si],0dh    ;at EOL?
   je endlbl                ;yes, quit
   mov di,6ch               ;FCB2
   mov ax,2901h             ;parse file name again
   int 21h                  ;call DOS
endlbl:
   pop es                   ;restore ES and quit
#endasm
         }
      regs.r.cs =
      regs.r.ds =
      regs.r.es =
      regs.r.ss = pspaddr;
      regs.r.sp = 0xfffe;  /* set stack pointer */
      regs.r.ip = 0x100;
      POKE(0xcd,virtualseg,0x100);  /* Int instruction */
      POKE(0x20,virtualseg,0x101);  /* Int 20 = return to DOS */
      POKE(0,virtualseg,0xfffe);
      POKE(0,virtualseg,0xffff);  /* a word of 0 on the stack */
      }
   else
      {
      PUTS("Not enough memory!\n");
      regs.r.sp = 0x1ffe;  /* set stack pointer */
      regs.r.cs = fromseg - 1;
      regs.r.ss = fromseg - 0x200;
      regs.r.ip = 0;
      POKE(0xcd,regs.r.cs+segoffset+rom_offset,0);  /* Int instruction */
      POKE(0x19,regs.r.cs+segoffset+rom_offset,1);  /* Int 19 = boot system */
      }
   /* disable interrupts while vectors are being changed */
#asm
   cli    ;NO INTERUPTS!  INLINE ASSEMBLER IS COMPILER SPECIFIC!
#endasm
   func = ctrlchdlr;  /* set up for Int 0x23 (Ctrl-C) handler */
   setmchnvectors(func,0x8c);
       /* and no call locations are needed */

/* IMPORTANT: Turn interrupts back on */
#asm
   sti   ;Interrupts OK now.  INLINE ASSEMBLER IS COMPILER SPECIFIC!
#endasm
   }

void set_attr_reg(index,value)
   unsigned int index,value;
   {
#asm
;
;  Since I need assembly, I may as well do the whole thing in assembly
;
   push bp     ;AZTEC ONLY:  need C prefix code
   mov bp,sp   ;AZTEC ONLY:  need C prefix code
   mov dx,word ptr feature_addr_  ;get I/O address
   mov cx,0ffffh                  ;a big number, but NOT forever
set_attr_reg_wait:
   in al,dx                       ;get input status reg 1
   test al,8                      ;in retrace?
   loopz set_attr_reg_wait        ;no, try again
   mov dl,0c0h                    ;I/O address
   mov al,byte ptr [bp+4]         ;get reg index
   out dx,al                      ;out it
   mov al,byte ptr [bp+6]         ;get reg value
   jmp short s_a_r_1              ;pause a microsecond
s_a_r_1:
   out dx,al                      ;set reg value
   pop bp      ;AZTEC ONLY:  need C suffix code
#endasm
#ifdef NEVERDEF
/*   INBPORT(feature_addr); */  /* reset flip-flop */
    /* wait for retrace automatically does an INBPORT from the feature addr */
   OUTBPORT(index,0x3c0);
   OUTBPORT(value,0x3c0);
#endif
   }

void setvimscreen()  /* restore saved screen memory and 6845 state for
                        the use of the program being interpreted */
   {
   int i;

   swapscreens();
#asm
   cli       ;no interrupts while changing video modes!
#endasm
   if ((egascreen > 0) || (vgascreen > 0))
      {
      swapegachrs();
      out2bports(0x11,0,videobase);  /* needed for TECMAR VGA */
      out2bports(0,1,0x3c4);  /* reset sequencer */
      for (i = 1; i <= seq_reg_count; i++)
         out2bports(i,seqregs[i],0x3c4);
      OUTBPORT(egaports[P3C2],0x3c2);  /* misc. register */
      OUTBPORT(egaports[P3xA],feature_addr);
      if (extended_swap)
         {
         OUTBPORT(egaports[P3CB],0x3cb);
         OUTBPORT(egaports[P3CD],0x3cd);
         OUTBPORT(mdaports[P3BF],0x3bf);
         }
      out2bports(0,3,0x3c4);  /* reset sequencer */
/*      out2bports(0x11,0,videobase); */ /* needed for VGA */
      for (i = 0; i <= crt_reg_count; i++)
         if (videobase < 0x3d0)
            out2bports(i,mdaregs[i],0x3b4);
         else
            out2bports(i,cgaregs[i],0x3d4);

/* set_attr_reg(0x10,attribregs[0x10]);
set_attr_reg(0x12,attribregs[0x12]);
set_attr_reg(0x13,attribregs[0x13]); */

      for (i = 0; i <= si_reg_count; i++)
         out2bports(i,siregs[i],0x3ce);
      for (i = 0; i <= attrib_reg_count ; i++)
         set_attr_reg(i,attribregs[i]);
      if (vgascreen > 0)
         {
         OUTBPORT(egaports[P3C3],0x3c3);
         OUTBPORT(egaports[P3C6],0x3c6);
         set_dac_regs(vga_virt_dac);
         OUTBPORT(egaports[P3C8],0x3c7+egaports[P3C7]);
         }
      else
         {
         OUTBPORT(egaports[P3CC],0x3cc);
         OUTBPORT(egaports[P3CA],0x3ca);
         }
      out2bports(0,seqregs[0],0x3c4);  /* set sequencer reset mode */
      OUTBPORT(egaports[P3C4],0x3c4);  /* set seq index */
      if (videobase < 0x3d0)           /* set CRTC index */
         OUTBPORT(mdaports[P3B4],0x3b4);
      else
         OUTBPORT(cgaports[P3D4],0x3d4);
      OUTBPORT(egaports[P3CE],0x3ce);  /* set Graphics SI index */
      INBPORT(feature_addr);  /* reset flip flop */
      OUTBPORT(egaports[P3C0],0x3c0);  /* set attribute index */
      if (!attribflipflop)  /* if flip flop is at index */
         INBPORT(feature_addr);  /* set it that way */
      }
   else
      {
      if (videobase == 0x3b4)  /* if monochrome */
         {
         for (i = 0; i < 18; i++)
            out2bports(i,mdaregs[i],0x3b4);
         OUTBPORT(mdaports[P3B8],0x3b8);  /* set 6845 mode */
         if (hercules)
            OUTBPORT(mdaports[P3BF],0x3bf);
         }
      else
         {
         for (i = 0; i < 18; i++)
            out2bports(i,cgaregs[i],videobase);
         OUTBPORT(cgaports[P3D8],0x3d8);
         OUTBPORT(cgaports[P3D9],0x3d9);
         }
      }
#asm
   sti     ;OK to allow interrupts again
#endasm
   }

void setrealscreen()  /* set video mode for VIM's use */
   {
   int i;

#asm
   cli        ;no interrupts while changing video modes
#endasm
   if ((egascreen > 0) || (vgascreen > 0))
      {
      swapegachrs();
      if (vgascreen > 0)
         {
         egaports[P3C7] = INBPORT(0x3c7) & 1;
         egaports[P3C8] = INBPORT(0x3c8) - egaports[P3C7];  /* write is 1 less */
         get_dac_regs(vga_virt_dac);
         set_dac_regs(vga_norm_dac);
         }
      setegamode(1);
      }
   else
      {
      if (videobase < 0x3d0)  /* if monochrome */
         {
         for (i = 0; i < 18; i++)
            out2bports(i,mdamode[i],0x3b4);
         OUTBPORT(mdap3b8,0x3b8);  /* set 6845 mode */
         if (hercules)
            OUTBPORT(mdap3bf,0x3bf);  /* set hercules mode */
         }
      else
         {
         for (i = 0; i < 18; i++)
            out2bports(i,cgamode[i],0x3d4);
         OUTBPORT(cgap3d8,0x3d8);
         OUTBPORT(cgap3d9,0x3d9);
         }
      }
#asm
   sti     ;OK to allow interrupts again
#endasm
   swapscreens();
   }

void setvideoregs()
   {
   int i;
   unsigned int romseg,romofs,romofs2,to,ts;

   OUTBPORT(14,0x3b4);  /* MDA cursor MSB */
   mdamode[14] = INBPORT(0x3b5);  /* get MDA cursor MSB */
   OUTBPORT(15,0x3b4);  /* MDA cursor LSB */
   mdamode[15] = INBPORT(0x3b5);
   OUTBPORT(14,0x3d4);  /* CGA cursor MSB */
   cgamode[14] = INBPORT(0x3d5);
   OUTBPORT(15,0x3d4);  /* CGA cursor LSB */
   cgamode[15] = INBPORT(0x3d5);
   mdaports[P3B8] = mdap3b8;  /* set 6845 mode */
   mdaports[P3BF] = mdap3bf;  /* hercules mode */
   cgaports[P3D8] = cgap3d8;
   cgaports[P3D9] = cgap3d9;
   for (i = 0; i < 18; i++)  /* restore default video modes */
      {
      mdaregs[i] = mdamode[i];
      cgaregs[i] = cgamode[i];
      }
   if (egascreen > 0)
      {
      to = wpeek(0,0x4a8);
      ts = wpeek(0,0x4aa);
      romofs = wpeek(ts,to) + (0x40 * egascreen);
      romseg = wpeek(ts,to+2);
      seqnorm[0] =
      seqregs[0] = 3;
      for (i = 1; i < 5; i++)
         {
         seqnorm[i] =
         seqregs[i] = PEEK(romseg,romofs+4+i);
         }
      for (i = 0; i < 25; i++)
         {
         mdanorm[i] =
         mdaregs[i] =
         cganorm[i] =
         cgaregs[i] = PEEK(romseg,romofs+i+0x0a);
         }
      for (i = 0; i < 20; i++)
         {
         attribnorm[i] =
         attribregs[i] = PEEK(romseg,romofs+i+0x23);
         }
      for (i = 0; i < 9; i++)
         {
         sinorm[i] =
         siregs[i] = PEEK(romseg,romofs+i+0x37);
         }
      mdanorm[14] =
      mdaregs[14] = mdamode[14];  /* get MDA cursor MSB */
      mdanorm[15] =
      mdaregs[15] = mdamode[15];
      cganorm[14] =
      cgaregs[14] = cgamode[14];
      cganorm[15] =
      cgaregs[15] = cgamode[15];
      if (egascreen == 0x16)
         {
         cganorm[10] =
         cgaregs[10] = 0x0b;
         cganorm[11] =
         cgaregs[11] = 0x0d;  /* enhanced cursor */
         }
      egaports[NORMAL_P3C2] =
      egaports[P3C2] = PEEK(romseg,romofs+9);
      egaports[P3xA] =
      egaports[P3CC] =
      egaports[P3CB] =
/*      egaports[NORMAL_P3CB] = */  /* leave at C's initial 0 */
      egaports[P3CD] =
/*      egaports[NORMAL_P3CD] = */
/*      egaports[NORMAL_P3BF] = */
      mdaports[P3BF] = 0;
      egaports[P3CA] = 1;
      egaports[NORMAL_P3C0] =
      egaports[P3C0] = 0x20;
      }
   if (vgascreen > 0)
      getvgaregs();
   }

void out2bports(val1,val2,port)
   unsigned int val1, val2, port;
   {
#asm
   push bp     ;AZTEC ONLY:  need C prefix code
   mov bp,sp   ;AZTEC ONLY:  need C prefix code
   mov dx,word ptr [bp+8]
   mov al,byte ptr [bp+4]
   out dx,al
   jmp short delay_1
delay_1:
   mov al,byte ptr [bp+6]
   inc dx
   out dx,al
   pop bp      ;AZTEC ONLY:  need C suffix code
#endasm
   }

void setegamode(which)
   int which;
   {
   int i;

   if (!which)
      {
      out2bports(2,4,0x3c4);  /* set map mask reg to 4
                                     (bit plane 2 active for write) */
      out2bports(4,7,0x3c4);  /* set memory mode reg,
                                bits 0-2 alpha, extended mem, odd */
      out2bports(4,2,0x3ce);  /* set read map select reg  read plane 2 */
      out2bports(5,0,0x3ce);  /* set mode reg, read and write mode is 0 */
      out2bports(6,4,0x3ce);  /* set misc reg: text, odd maps to even,
                                64K at A000 */
      out2bports(8,0xff,0x3ce);  /* set bit mask */
      }
   else
      {
      out2bports(0x11,0,videobase);  /* needed for TECMAR VGA */
      out2bports(0,1,0x3c4);  /* reset sequencer */
      for (i = 1; i <= seq_reg_count; i++)
         out2bports(i,seqnorm[i],0x3c4);
      OUTBPORT(egaports[NORMAL_P3C2],0x3c2);
      OUTBPORT(0,feature_addr);
      if (extended_swap)
         {
         OUTBPORT(egaports[NORMAL_P3CB],0x3cb);
         OUTBPORT(egaports[NORMAL_P3CD],0x3cd);
         OUTBPORT(egaports[NORMAL_P3BF],0x3bf);
         }
      out2bports(0,3,0x3c4);  /* start sequencer */
/*      out2bports(0x11,0,videobase); */ /* needed for VGA */
      for (i = 0; i <= crt_reg_count; i++)
         if (videobase < 0x3d0)
            out2bports(i,mdanorm[i],0x3b4);
         else
            out2bports(i,cganorm[i],0x3d4);

/* set_attr_reg(0x10,attribnorm[0x10]);
set_attr_reg(0x12,attribnorm[0x12]);
set_attr_reg(0x13,attribnorm[0x13]); */

      for (i = 0; i <= si_reg_count; i++)
         out2bports(i,sinorm[i],0x3ce);
      for (i = 0; i <= attrib_reg_count; i++)
         set_attr_reg(i,attribnorm[i]);
      OUTBPORT(egaports[NORMAL_P3C4],0x3c4);  /* set seq index */
      if (videobase < 0x3d0)           /* set CRTC index */
         OUTBPORT(egaports[NORMAL_P3x4],0x3b4);
      else
         OUTBPORT(egaports[NORMAL_P3x4],0x3d4);
      OUTBPORT(egaports[NORMAL_P3CE],0x3ce);  /* set Graphics SI index */
      if (vgascreen > 0)
         {
         OUTBPORT(egaports[NORMAL_P3C3],0x3c3);
         OUTBPORT(egaports[NORMAL_P3C6],0x3c6);
         }
      else
         {
         OUTBPORT(0,0x3cc);
         OUTBPORT(1,0x3ca);
         }
      INBPORT(feature_addr);
      OUTBPORT(egaports[NORMAL_P3C0],0x3c0);  /* allow access to palette regs */
      }
   }


void swapscreens()
   {
#ifdef NEVERDEF
/*
   Note:  This C codewill swap screens, but it is unbearably slow.  The
   inline assembler below does the same job much faster, but is not
   transportable.
*/
   int i;
   unsigned int screenseg,hold;

   screenseg = 0xb800;  /* set screen memory segment */
   if (videobase == 0x3b4)
      screenseg = 0xb000;
   for (i = 0; i < 4096; i++)  /* swap all bytes */
      {
      hold = screen[i];
      screen[i] = PEEK(screenseg,i);
      POKE(hold,screenseg,i);
      }
#endif

#asm
   mov ax,0b800h              ;default CGA video segment
   cmp word ptr videobase_,03b4h  ;is this a MDA machine?
   jne swsl1                  ;no, skip
   mov ax,0b000h              ;yes, set MDA video segment
swsl1:
   mov es,ax                  ;set segment
   xor di,di                  ;es:di = video memory
   mov si,di                  ;es:si = video memory, as well
   cld                        ;autoinc string primitives
   mov bx,offset screen_      ;ds:bx = screen storage
   mov cx,0800h               ;2048 words
swsl2:
   db 26h                     ;es:
   lodsw                      ;fetch word
   xchg ax,word ptr [bx]      ;swap words
   inc bx                     ;update pointer into screen
   inc bx
   stosw                      ;store word
   loop swsl2
#endasm
   }

void saveegachrs()
   {
   setegamode(0);  /* force to EGA internal mode */
#asm
   mov ax,0a000h              ;video memory base
   push ds                    ;save ds
   push ds                    ;and move ds
   pop es                     ;into es
   mov ds,ax                  ;set segment
   mov si,0                   ;DS:SI = video segment
   mov di,offset screen_      ;ES:DI = saved screen
   add di,1002h               ;ES:DI = character save area in screen
   cld                        ;autoinc string primitives
   mov cx,2000h               ;read 8192 bytes
;   mov dx,03ceh               ;Graphics 1&2 address register
;   mov al,4                   ;select register 4
;   out dx,al                  ;out it
;   inc dx                     ;register address
;   mov al,2                   ;read character generator info
;   out dx,al                  ;out it
   db 0f3h                    ;rep prefix
   movsb                      ;make a copy
   pop ds                     ;restore DS
#endasm
   setegamode(1);  /* set to regular EGA mode */
   }

void swapegachrs()
   {
   setegamode(0);  /* force to EGA internal mode */
#asm
   mov ax,0a000h              ;video memory base
   mov es,ax                  ;set segment
   mov di,0                   ;ES:DI = video segment
   mov si,di                  ;ES:SI = video segment, as well
   mov bx,offset screen_      ;DS:BX = saved screen
   add bx,1002h               ;DS:BX = character save area in screen
   mov cx,1000h               ;move 8192 bytes (4096 words)
;   mov dx,03c4h               ;sequencer address register
;   mov al,2                   ;select register 2
;   out dx,al                  ;out it
;   inc dx                     ;register address
;   mov al,4                   ;write to bit plane 2 (2^(plane))
;   out dx,al                  ;out it
;   mov dx,03ceh               ;Graphics 1&2 address register
;   mov al,4                   ;select register 4
;   out dx,al                  ;out it
;   inc dx                     ;register address
;   mov al,2                   ;read character generator info
;   out dx,al                  ;out it
   cld                        ;autoinc string primitives
swegachrs2:
   db 26h                     ;es:
   lodsw                      ;fetch word
   xchg ax,word ptr [bx]      ;swap words
   inc bx                     ;update pointer into screen
   inc bx
   stosw                      ;store word
   loop swegachrs2
#endasm
      /* no need to set normal EGA mode, the calling routine will do that */
   }

void get_dac_regs(ptr)
   char *ptr;
   {
   int i;

#asm
   cli   ;DO NOT DISTURB!
#endasm
   OUTBPORT(0,0x3c7);  /* set DAC read addr */
   for (i = 0; i < 768; i++)  /* 256 regs * 3 colors */
      *(ptr++) = INBPORT(0x3c9);  /* get this reg */
#asm
   sti   ;ints are OK again
#endasm
   }   

void set_dac_regs(ptr)
   char *ptr;
   {
   int i;

#asm
   cli   ;DO NOT DISTURB!
#endasm
   OUTBPORT(0,0x3c8);  /* set DAC write addr */
   for (i = 0; i < 768; i++)  /* 256 regs * 3 colors */
      OUTBPORT(*(ptr++),0x3c9);  /* set this reg */
#asm
   sti   ;ints are OK again
#endasm
   }   

void getvgaregs()  /* called with NORMAL video state */
   {
   int i;

   egaports[P3C4] =
   egaports[NORMAL_P3C4] = INBPORT(0x3c4);
   egaports[NORMAL_P3x4] = INBPORT(videobase);
   if (videobase < 0x3d0)
      mdaports[P3B4] = egaports[NORMAL_P3x4];
   else
      cgaports[P3D4] = egaports[NORMAL_P3x4];
   egaports[P3CE] =
   egaports[NORMAL_P3CE] = INBPORT(0x3ce);
   INBPORT(feature_addr);  /* reset flip-flop */
   egaports[NORMAL_P3C0] =
   egaports[P3C0] = INBPORT(0x3c0);  /* get attribute index */
   egaports[P3C2] =
   egaports[NORMAL_P3C2] = INBPORT(0x3cc);  /* get 0x3c2 port from here on VGA */
   egaports[P3C3] =
   egaports[NORMAL_P3C3] = INBPORT(0x3c3);
   egaports[P3C6] =
   egaports[NORMAL_P3C6] = INBPORT(0x3c6);
   egaports[P3xA] = INBPORT(0x3ca);  /* feature port */
   if (extended_swap)
      {
      egaports[P3CB] =
      egaports[NORMAL_P3CB] = INBPORT(0x3cb);
      egaports[P3CD] =
      egaports[NORMAL_P3CD] = INBPORT(0x3cd);
      mdaports[P3BF] =
      egaports[NORMAL_P3BF] = INBPORT(0x3bf);
      }
   for (i = 0; i <= seq_reg_count; i++)
      {
      OUTBPORT(i,0x3c4);  /* set index */
      seqnorm[i] =
      seqregs[i] = INBPORT(0x3c5);   /* get value */
      }
   for (i = 0; i <= crt_reg_count; i++)
      {
      OUTBPORT(i,videobase);
      mdanorm[i] =
      mdaregs[i] =
      cganorm[i] =
      cgaregs[i] = INBPORT(videobase+1);
      }
   for (i = 0; i <= si_reg_count; i++)
      {
      OUTBPORT(i,0x3ce);  /* set index */
      sinorm[i] =
      siregs[i] = INBPORT(0x3cf);  /* get value */
      }
   for (i = 0; i <= attrib_reg_count; i++)
      {
      INBPORT(feature_addr);  /* reset flip-flop */
      OUTBPORT(i,0x3c0);  /* set index */
      attribnorm[i] =
      attribregs[i] = INBPORT(0x3c1);  /* get value */
      }
   egaports[P3C7] = INBPORT(0x3c7) & 1;
   egaports[P3C8] = INBPORT(0x3c8) - egaports[P3C7];  /* write is 1 less */
   get_dac_regs(vga_norm_dac);
   get_dac_regs(vga_virt_dac);
   INBPORT(feature_addr);  /* allow access to palette regs */
   OUTBPORT(egaports[NORMAL_P3C0],0x3c0);
   }

int parse(str)  /* parse next token from cmdline, return FALSE if nothing
                   left to parse, else TRUE */
   char *str;
   {
   int i,inquote;  /* inquote allows a single/double quoted string to be
                      processed as one token */
   unsigned int whichquote;

   inquote = FALSE;
   i = 0;
   str[0] = '\0';
   while ((cmdline[cmdptr])
          && ((cmdline[cmdptr] == ' ')
              || (cmdline[cmdptr] == '\t') || (cmdline[cmdptr] == ',')
              || (cmdline[cmdptr] == '=')))
      cmdptr++;
   if (cmdline[cmdptr])
      {
      while ((cmdline[cmdptr])
              && (((cmdline[cmdptr] != ' ')
              && (cmdline[cmdptr] != '\t') && (cmdline[cmdptr] != ',')
              && (cmdline[cmdptr] != '='))
              || (inquote)))
         {
         if ((cmdline[cmdptr] == '\"') || (cmdline[cmdptr] == '\''))
            if (inquote)
               {
               if (cmdline[cmdptr] == whichquote)
                  inquote = FALSE;
               }
            else
               {
               inquote = TRUE;
               whichquote = cmdline[cmdptr];
               }
         str[i++] = cmdline[cmdptr++];
         }
      str[i] = '\0';
      }
   if ((!cmdline[cmdptr]) && (i == 0))  /* if only spaces, etc, were left */
      return(FALSE);
   return(TRUE);
   }

int isregname(name)  /* change name to upper case, return index value if
                        a valid register name, else return -1 */
   char *name;
   {
   int count,index;
   char str[4];

   index = -1;
   if (strlen(name) == 2)  /* if this could be a register name */
      {
      strcpy(str,name);  /* make a local copy */
      strupr(str);  /* force upper case */
      if ((strcmp(str,"IP") == 0) || (strcmp(str,"PC") == 0))
         index = 13;
      else
         for (count = 0; count < 12; count++)
                                      /* DAX-DAX to DDS-DAX */
            if (strcmp(regnames[count],str) == 0)
               index = count;
      }
   return(index);
   }

int numval(str,val)  /* change hex value in str to a number */
                     /* return FALSE if invalid hex number, else TRUE */
   unsigned char *str;
   UNSIGNED_LONG *val;  /* Beware of passing an INT pointer to this routine
                           if the machine does not use low-byte first! */
   {
   int i,valid;
   unsigned int ch;

   i = 0;
   *val = 0;
   valid = FALSE;
   ch = toupper(str[i++]);
   while (ch)
      {
      valid = TRUE;
      if (isdigit(ch))
         *val = (*val << 4) + ch - '0';  /* a number */
      else
         if ((ch >= 'A') && (ch <= 'F'))  /* a letter */
            *val = (*val << 4) + ch - 'A' + 10;
         else
            {
            if ((i = isregname(str)) > -1)  /* if this is a register name */
               {
               *val = regs.wordarray[i];  /* return the register's value */
               return(TRUE);
               }
            else
               return(FALSE);
            }
      ch = toupper(str[i++]);
      }
   return(valid);
   }

/*
int instring(ch,str)
   unsigned char ch;
   unsigned char *str;
   {
   int i,j;

   j = -1;
   i = 0;
   while ((str[i]) && (j < 0))
      if (str[i++] == ch)
         j = i-1;
   return(j);
   }
*/

int instring(ch,str)
   unsigned char ch;
   unsigned char *str;
   {
   int i,j;

   j = -1;
   i = strlen(str);
   while ((i > -1) && (j < 0))
      if (str[i--] == ch)
         j = i+1;
   return(j);
   }

int fromhex(str,val)
   char *str;
   UNSIGNED_LONG *val;
   {
   fromhex_pos = 0;
   num_paren = 0;
   num_square = 0;
   num_curly = 0;
   if (balance(str,0))
      {
      strcpy(tempstr,str);
      if (evalhex(tempstr,val))
         return(TRUE);
      }
   return(FALSE);
   }

int balance(str,type)
   char *str;
   int type;
   {
   int valid,startpos, colonpos, seg;

   valid = TRUE;
   while ((str[fromhex_pos]) && (valid))
      {
      if (str[fromhex_pos] == '(')
         {
         num_paren++;
         startpos = fromhex_pos++;
         if (valid = balance(str,1))
            {
            strcpy(tempstr,&str[startpos+1]);
            tempstr[fromhex_pos-startpos-2] = '\0';
            if (valid = evalhex(tempstr,&fromhex_temp))
               {
               strcpy(tempstr,&str[fromhex_pos]);
               hexword(&fromhex_temp,&str[startpos]);
               strcat(str,tempstr);
               fromhex_pos = startpos + 4;  /* 4 for length of hexword() string */
               }
            }
         }
      else
         {
         if (str[fromhex_pos] == '[')
            {
            num_square++;
            startpos = fromhex_pos++;
            if (valid = balance(str,2))
               {
               strcpy(tempstr,&str[startpos+1]);
               tempstr[fromhex_pos-startpos-2] = '\0';
               seg = regs.r.ds;
               if ((colonpos = instring(':',tempstr)) > -1)
                  {
                  tempstr[colonpos] = '\0';
                  if (valid = evalhex(tempstr,&fromhex_temp))
                     seg = fromhex_temp;
                  }
               if ((valid) && (valid = evalhex(&tempstr[colonpos+1],&fromhex_temp)))
                  {
                  strcpy(tempstr,&str[fromhex_pos]);
                  fromhex_temp = fetchword(seg,(int)fromhex_temp);
                  hexword(&fromhex_temp,&str[startpos]);
                  strcat(str,tempstr);
                  fromhex_pos = startpos + 4;  /* 4 for length of hexword() string */
                  }
               }
            }
         else
            {
            if (str[fromhex_pos] == LEFT_BRACE)
               {
               num_curly++;
               startpos = fromhex_pos++;
               if (valid = balance(str,3))
                  {
                  strcpy(tempstr,&str[startpos+1]);
                  tempstr[fromhex_pos-startpos-2] = '\0';
                  seg = regs.r.ds;
                  if ((colonpos = instring(':',tempstr)) > -1)
                     {
                     tempstr[colonpos] = '\0';
                     if (valid = evalhex(tempstr,&fromhex_temp))
                        seg = fromhex_temp;
                     }
                  if ((valid) && (valid = evalhex(&tempstr[colonpos+1],&fromhex_temp)))
                     {
                     strcpy(tempstr,&str[fromhex_pos]);
                     fromhex_temp = fetchbyte(seg,(int)fromhex_temp);
                     hexword(&fromhex_temp,&str[startpos]);
                     strcat(str,tempstr);
                     fromhex_pos = startpos + 4;  /* 4 for length of hexword() string */
                     }
                  }
               }
            else
               {
               if (str[fromhex_pos] == ')')
                  {
                  if ((num_paren == 0) || (type != 1))
                     return(FALSE);
                  else
                     {
                     num_paren--;
                     fromhex_pos++;
                     return(TRUE);
                     }
                  }
               else
                  {
                  if (str[fromhex_pos] == ']')
                     {
                     if ((num_square == 0) || (type != 2))
                        return(FALSE);
                     else
                        {
                        num_square--;
                        fromhex_pos++;
                        return(TRUE);
                        }
                     }
                  else
                     {
                     if ((str[fromhex_pos] == RIGHT_BRACE) && (valid))
                        {
                        if ((num_curly == 0) || (type != 3))
                           return(FALSE);
                        else
                           {
                           num_curly--;
                           fromhex_pos++;
                           return(TRUE);
                           }
                        }
                     else
                        fromhex_pos++;
                     }  /* end of else of if ']' */
                  }  /* end of else of if ')' */
               }  /* end of else of if LEFT_BRACE */
            }  /* end of else of if '[' */
         }  /* end of else of if '(' */
      }  /* end of while */
   if ((num_paren) || (num_square) || (num_curly))
      valid = FALSE;
   return(valid);
   }

int evalhex(str,val)  /* parse and evaluate an expression */
   unsigned char *str;
   UNSIGNED_LONG *val;
   {
   int loc,valid,whichop,count,flag;
   UNSIGNED_LONG lnum,lnum2,temp2;

   valid = TRUE;
   whichop = 0;
   do
      {
      if ((loc = instring(operatorstr[whichop],str)) > -1)
         {
         str[loc] = '\0';
         if ((str[loc+1]) && (evalhex(&str[loc+1],&lnum2)))
            {
            if ((operatorstr[whichop] == '~')
                                || ((loc > 0) && (evalhex(str,&lnum))))
               {
               switch (operatorstr[whichop])
                  {
                  case '^':  /* XOR */
                     *val = lnum ^ lnum2;
                     break;
                  case '|':  /* OR */
                     *val = lnum | lnum2;
                     break;
                  case '&':  /* AND */
                     *val = lnum & lnum2;
                     break;
                  case '<':  /* shift left */
                     temp2 = lnum2 & 0x0fL;
                     *val = lnum;
                     if (temp2)
                        {
                        *val <<= temp2;
                        *val |= (lnum >> (16-temp2));
                        }
                     break;
                  case '>':  /* shift right */
                     temp2 = lnum2 & 0x0fL;
                     *val = lnum;
                     if (temp2)
                        {
                        *val >>= temp2;
                        *val |= (lnum << (16-temp2));
                        }
                     break;
                  case '-':  /* subtract */
                     *val = lnum - lnum2;
                     break;
                  case '+':  /* addition */
                     *val = lnum + lnum2;
                     break;
                  case '%':
                     if (lnum2)
                        {
                        *val = lnum % lnum2;
                        }
                     else
                        valid = FALSE;
                     break;
                  case '/':  /* division */
                     if (lnum2)
                        {
                        *val = lnum / lnum2;
                        }
                     else
                        valid = FALSE;
                     break;
                  case '*':  /* multiplication */
                     *val = lnum * lnum2;
                     break;
                  case '~':  /* NOT */
                     if (loc == 0)
                        *val = ~lnum2;
                     else
                        {
                        flag = 1;
                        for (count = 0; count < NUMOPS; count++)
                           {
                           if (str[loc-1] == operatorstr[count])
                              flag = 0;
                           }
                        if (flag)
                           valid = FALSE;
                        else
                           *val = ~lnum2;
                        }
                     break;
                  }  /* end of switch */
               if (valid)
                  return(valid);
               }  /* end of if */
            else
               valid = FALSE;
            }
         else
            valid = FALSE;
         }
      else
         whichop++;
      } while ((whichop < NUMOPS) && (valid));
   if (valid)
      valid = numval(str,val);
   return(valid);
   }

int getnumber(longnum)
   UNSIGNED_LONG *longnum;
   {
   int ok_return;

   ok_return = 0;  /* default to bad return */
   if (parse(globalstr))
      ok_return = fromhex(globalstr,longnum);
   return(ok_return);
   }

int getprotrange(seg,ofs,ofs2)
   unsigned int *seg, *ofs, *ofs2;
/*
   Passed parms not specified in the command line are not changed.
   On an input error, no values are changed.
   Expected format:  [seg:]ofs[,ofs2]   ofs2 >= ofs
                     if ,ofs2 missing, ofs2 = ofs
                 wrong format, etc, gives err return and message out
   Returns:  1 = all ok
             0 = err
            -1 = nothing more on command line
*/
   {
   UNSIGNED_LONG hold,hold1,hold2,hold3,ok_return;
   int colonpos;

   hold1 = *seg;
   hold2 = *ofs;
   hold3 = *ofs2;
   ok_return = 1;  /* default to ok */
   if (!parse(globalstr))
      ok_return = -1;  /* empty command line */
   else
      if (!fromhex(globalstr,&hold))
         {
         if ((colonpos = instring(':',globalstr)) == -1)
            ok_return = 0;  /* bad number */
         else
            {
            globalstr[colonpos] = '\0';
            if (!fromhex(globalstr,&hold1))
               ok_return = 0;
            else
               if (!fromhex(&globalstr[colonpos+1],&hold))
                  ok_return = 0;
            }
         }
   if (ok_return == 1)
      {
      hold2 = hold;
      hold3 = hold;
      if (cmdline[cmdptr] == ',')
         {
         if (!getnumber(&hold))
            ok_return = 0;
         else
            if (hold < hold2)
               ok_return = 0;
            else
               hold3 = hold;
         }
      }
   if (ok_return == 1)
      {
      *seg = (unsigned int)hold1;
      *ofs = (unsigned int)hold2;
      *ofs2 = (unsigned int)hold3;
      }
   else
      if (ok_return == 0)
         oops(err_rng);
   return(ok_return);
   }

int getaddrange(seg,ofs,ofs2,numofargs)
   unsigned int *seg, *ofs, *ofs2;
   unsigned int numofargs;  /* flag that says how many arguments must be
                               entered:
                               6 = none needed, if ofs entered and ofs2 is
                                   not, set ofs2 to ofs+0x3f (for DumpWord)
                               5 = need seg:ofs
                               4 = none needed, if ofs entered and ofs2 is
                                   not, set ofs2 to ofs+0x7f (for Dump)
                               3 = none needed, if ofs entered and ofs2 is
                                   not, set ofs2 to ofs+0x1f (for Unasm)
                               2 = two offsets wanted
                               1 = one offset wanted
                               0 = either wanted */
/*
   Passed parms not specified in the command line are not changed.
   On an input error, no values are changed.
   Expected format:  [seg:]ofs [ {Lxxxx}{ofs2} ]  ofs2 >= ofs
                 wrong format, etc, gives err return and message out
   Returns:  1 = all ok
             0 = err
*/
   {
   UNSIGNED_LONG hold,hold1,hold2,hold3,flag,ok_return,valid;
   int colonpos;

   hold1 = *seg;
   hold2 = *ofs;
   hold3 = *ofs2;
   ok_return = 1;  /* default to ok */
   valid = TRUE;
   if (valid = parse(globalstr))
      {
      if (!(valid = fromhex(globalstr,&hold)))
         {
         ok_return = 0;
         if ((colonpos = instring(':',globalstr)) != -1)
            {
            globalstr[colonpos] = '\0';
            if ((fromhex(globalstr,&hold1))
                    && (valid = fromhex(&globalstr[colonpos+1],&hold)))
               ok_return = 1;  /* OK again */
            }
         }
      }
   else
      if (numofargs == 5)
         ok_return = 0;
   if (valid)
      {
      if ((numofargs == 5) && (colonpos == -1))
         ok_return = 0;
      hold2 = hold;
      if (numofargs == 3)
         hold3 = hold2 + 0x1f;
      if (numofargs == 4)
         hold3 = hold2 + 0x7f;
      if (numofargs == 6)
         hold3 = hold2 + 0x3f;
      if ((numofargs != 1) && (numofargs != 5))
         {
         if ( (((flag = parse(globalstr)) != TRUE) && (numofargs == 2)) || (!ok_return))
            ok_return = 0;
         else
            if (flag)
               {
               if (toupper(globalstr[0]) == 'L')
                  {
                  flag = fromhex(&globalstr[1],&hold);
                  hold += hold2 - 1;
                  }
               else
                  {
                  flag = fromhex(globalstr,&hold);
                  if (numofargs == 6)
                     hold = ((hold-hold2) >> 1) + hold2;
                  }
               if (!flag)
                  ok_return = 0;
               else
                  hold3 = hold;
               }
         }
      }
   if (ok_return)
      {
      *seg = (unsigned int)hold1;
      *ofs = (unsigned int)hold2;
      *ofs2 = (unsigned int)hold3;
      }
   else
      if (numofargs < 4)
         oops(err_rng);
   return(ok_return);
   }

void fillenter(mode,fillorenter)
   int mode,fillorenter;  /* mode = 1 -> enter,  mode = 2 -> fill */
/*
   Fill or enter.  The format is:
   F [seg:]ofs {ofs2 Llen} {byte string} [{byte string} ...]
       or
   E [seg:]ofs {byte string} [{byte string} ...]
*/
   {
   unsigned int seg,ofs,flag,count,countnum,len,keyin;
   unsigned int holdseg,holdofs,holdofs2;
   UNSIGNED_LONG temp,temp3;
   unsigned char values[256];

   holdseg = regs.r.ds;
   holdofs = 0;
   holdofs2 = 0;
   len = 0;
   if (getaddrange(&holdseg,&holdofs,&holdofs2,mode))  /* get addr range */
      {
      while (parse(globalstr))  /* get the next token */
         {
         if (isfillenterstr(globalstr))  /* check for legal string */
            for (count = 1; count < strlen(globalstr)-1; count++)
               values[len++] = globalstr[count];
         else
            if ((fromhex(globalstr,&temp3)) && (temp3 < 0x100L))
                                                      /* if a number */
               values[len++] = (unsigned char)temp3;
            else
               {
               oops(err_num);
               return;
               }
         }
      count = 0;
      if (mode == 2)  /* if FILL or SEARCH */
         holdofs2++;  /* inc holdofs2 so compare to holdofs will
                         include last byte */
      if (mode == 1)  /* if ENTER */
         holdofs2 = holdofs + len;
      keyin = 0;  /* not an ESC */
      if (len)
         if (fillorenter)
            {

#ifdef ZENITH
            if ( (( ((UNSIGNED_LONG)holdseg) << 4) + holdofs) >= 0xf0000L)
               {
               do
                  {
                  putbyte(holdseg,holdofs++,values[count++]);
                  if (count >= len)
                     count = 0;
                  } while (holdofs != holdofs2);
               }
            else
               {
#endif

               do
                  {
                  putbyte(holdseg,holdofs++,values[count++]);
                  if (count >= len)
                     count = 0;
                  } while (holdofs != holdofs2);

#ifdef ZENITH
               }
#endif
            }
         else  /* do a SEARCH */
            {
#ifdef ZENITH
            if ( (( ((UNSIGNED_LONG)holdseg) << 4) + holdofs) >= 0xf0000L)
               {
               do
                  {
                  if (fetchbyte(holdseg,holdofs++) == values[0])  /* if first byte equal */
                     {
                     flag = 1;  /* assume valid */
                     for (count = 1; count < len; count++)
                        {
                        if (fetchbyte(holdseg,holdofs+count-1) != values[count])
                     /* -1 since holdofs has already been incremented */
                           {
                           flag = 0;
                           count = len;
                           }
                        }
                     keyin = gchar();
                     if (flag)  /* if a match */
                        {
                        ofs = holdofs - 1;
                        PUTS(hexword(&holdseg,globalstr));
                        PUTS(":");
                        ofs = holdofs-1;  /* get original offset back */
                        PUTS(hexword(&ofs,globalstr));
                        PUTS(nl_str);
                        }
                     }
                  } while ((holdofs != holdofs2) && (keyin != ESC_KEY));
               }
            else
               {
#endif

               do
                  {
                  if (fetchbyte(holdseg,holdofs++) == values[0])  /* if first byte equal */
                     {
                     flag = 1;  /* assume valid */
                     for (count = 1; count < len; count++)
                        if (fetchbyte(holdseg,holdofs+count-1) != values[count])
                     /* -1 since holdofs has already been incremented */
                           {
                           flag = 0;
                           count = len;
                           }
                     keyin = gchar();
                     if (flag)  /* if a match */
                        {
                        PUTS(hexword(&holdseg,globalstr));
                        PUTS(":");
                        ofs = holdofs-1;  /* get original offset back */
                        PUTS(hexword(&ofs,globalstr));
                        PUTS(nl_str);
                        }
                     }
                  } while ((holdofs != holdofs2) && (keyin != ESC_KEY));

#ifdef ZENITH
               }
#endif
            }
      else
         oops(err_num);
      }
   }

int isfillenterstr(str)
                      /* is this a valid string for fill/enter ? */
   char *str;
   {
   if ((str[0] == '\"') || (str[0] == '\''))  /* if it starts with a quote */
      {
      if ((str[strlen(str)-1] != str[0]) || (strlen(str) < 3))
             /* if not matching quotes, or empty quotes */
         return(FALSE);
      else
         return(TRUE);
      }
   else  /* no starting quote, no good */
      return(FALSE);
   }

void oops(str)  /* say where and what on a command error */
   char *str;
   {
   int i;

   for (i = 0; i < asmspacing; i++)
      PUTS(space_str);
   for (i = 0; i < cmdptr; i++)
      if (cmdline[i] == '\t')
         PUTS(tab);
      else
         PUTS(space_str);
   PUTS("^");
   PUTS(str);
   valid = FALSE;
   }

void createfile()
   {
   unsigned int count,len,flag;
   int fileout,numout,outlen;
   unsigned char buf[1024];
   unsigned int seg,ofs,seg2,ofs2;
   UNSIGNED_LONG filelength;

   len = strlen(globalstr);
   flag = -1;
   for (count = len-1; count > 0; count--)
      if (globalstr[count] == '.')
         flag = count;
   if ((flag == -1) || (globalstr[flag+1] != 'E') || (globalstr[flag+2] != 'X')
                         || (globalstr[flag+3] != 'E'))
      {
      filelength = (((UNSIGNED_LONG)regs.r.bx.word) << 16)
                          + (UNSIGNED_LONG)regs.r.cx.word;
      if ((fileout = creat(globalstr)) == ERR)
         PUTS(err_fn);
      else
         {
         ofs = regs.r.ip & 0x000f;
         seg = regs.r.cs + ((regs.r.ip >> 4) & 0x0fff);
         do
            {
            outlen = ((filelength > 1024) ? 1024:filelength);
            for (count = 0; count < outlen; count++)
               buf[count] = fetchbyte(seg,ofs+count);
            numout = write(fileout,buf,outlen);
            if (numout != -1)
               {
               seg += (numout >> 4) & 0x0fff;  /* add offset for next write */
               ofs += numout & 0x000f;
               filelength -= numout;
               }
            else
               {
               PUTS("Error writing file.\n");
               filelength = 0;  /* and quit early */
               }
            } while (filelength);
         close(fileout);
         }
      }
   else
      PUTS("Cannot create an .EXE file. \n");
   }


void loadfile()  /* determine if an .EXE load has to be done, else load
                    in .COM (data) format */
   {
   unsigned int count,len,flag;

   globalstr[0] = '\0';
   len = strlen(filename);
   if (len)  /* if not blank */
      {
      flag = -1;  /* look for a period */
      for (count = len-1; count > 0; count--)
         if (filename[count] == '.')
            flag = count;   /* remember where it is */
      if ((flag > 0) && ((len-flag-1) == 3))  /* if a period was found
                                    and the extension length is 3 */
         {
         if ((filename[flag+1] == 'E')
                 && (filename[flag+2] == 'X')
                 && (filename[flag+3] == 'E'))
            load_exe();
         else
            load_com();
         }
      else
         load_com();
      }
   else
      PUTS(err_fn);
   }

void load_exe()  /* load and relocate as necessary an .EXE file */
   {
   struct imageheader
      {
      unsigned int exesignature;
      unsigned int lenmod512;
      unsigned int sizeinpages;
      unsigned int numofrelocitems;
      unsigned int headersize;
      unsigned int minmem;
      unsigned int maxmem;
      unsigned int ssdisp;
      unsigned int spvalue;
      unsigned int checksum;
      unsigned int ipvalue;
      unsigned int csdisp;
      unsigned int relocdisp;
      unsigned int ovlynumber;
      } header;
   union tableunion
      {
      unsigned char longstr[512];
      struct tables
         {
         unsigned int relocofs;
         unsigned int relocseg;
         } table[128];
      } tbl;
   unsigned char buf[1024];
   unsigned int relseg,relofs,tableindex,numreloc,seg,ofs,numin,temp;
   UNSIGNED_LONG minmem,filepos,filelen,tablepos;
   int filein;

   if ((filein = open(filename,MODE_READ)) == ERR)
      PUTS(err_fn);
   else
      {
      numin = read(filein,&header,28);  /* read initial header */
      if (header.exesignature != 0x5a4d)
         PUTS("invalid .EXE file.\n");
      else
         {
         filepos = header.headersize * 16;
         if ((header.sizeinpages * 32) - header.headersize + header.minmem
                  + pspaddr > maxpara)  /* if too big */
            PUTS("not enough memory.\n");
         else
            {
            regs.r.cs = pspaddr + 0x10 + header.csdisp;  /* set registers */
            regs.r.ss = pspaddr + 0x10 + header.ssdisp;
            regs.r.ds =
            regs.r.es = pspaddr;
            regs.r.sp = header.spvalue;
            regs.r.ip = header.ipvalue;
            seg = pspaddr;  /* variables for file load */
            ofs = 0x100;
            (*checkaddress)(&seg,&ofs);  /* translate address */
            lseek(filein,filepos,0);  /* seek past header */
            do
               {
               numin = read(filein,buf,1024);  /* read this chunk */
               if (numin)
                  {
                  MEMCPY(numin,datasegment,buf,seg,ofs);
                  seg += (numin >> 4) & 0x0fff;  /* paragraphs in */
                  ofs += numin & 0x000f;  /* bytes in */
                  filepos += numin;
                  }
               } while (numin);
            numin = 0;  /* be paranoid */
            tablepos = header.relocdisp;  /* this changes it to a long */
            lseek(filein,tablepos,0);
            while (numin < header.numofrelocitems)
               {
               if ((numin % 128) == 0)  /* if an empty relocation table */
                  {
                  tableindex = 0;
                  read(filein,tbl.longstr,512);
                                 /* read more of the table */
                  }
               relofs = tbl.table[tableindex].relocofs;
               relseg = pspaddr + segoffset + rom_offset + tbl.table[tableindex++].relocseg + 0x10;
               temp = wpeek(relseg,relofs);
               temp += pspaddr + 0x10;
               POKE( (temp & 0xff),relseg,relofs);  /* put back relocated
                                                       low byte */

               POKE( (temp >> 8) & 0xff,relseg,relofs+1); /* and high byte */
               numin++;
               }
            regs.r.cx.word = filepos & 0xffffL;  /* low word into CX */
            if (filepos > 0xffffL)  /* if a high word exists */
               regs.r.bx.word = (filepos >> 16) & 0xffffL;
                                          /* put it into BX */
            }  /* end of else */
         }  /* end of else */
      close(filein);
      }  /* end of else */
   }

void load_com()  /* I will try to make this transportable, but it will
                    probably wind up DeSmet specific */
   {
   int filein;
   unsigned char buf[1024];
   unsigned int numin,seg,ofs,seg2,ofs2,count;
   UNSIGNED_LONG filelength;

   filelength = 0L;
   if ((filein = open(filename,MODE_READ)) == ERR)
      PUTS(err_fn);
   else
      {
      ofs = regs.r.ip & 0x000f;
      seg = regs.r.cs + ((regs.r.ip >> 4) & 0x0fff);
      do
         {
         numin = read(filein,buf,1024);
         if (numin)
            {
            for (count = 0; count < numin; count++)
               putbyte(seg,ofs+count,buf[count]);
            seg += (numin >> 4) & 0x0fff;  /* add offset for next read */
            ofs += numin & 0x000f;
            filelength += numin;
            if (seg > maxpara)  /* if going off end of real memory */
               {
               PUTS("not enough memory.\n");
               numin = 0;  /* force an end to the load */
               }
            }
         } while (numin);
      regs.r.cx.word = filelength & 0xffffL;  /* set bx:cx to file length */
      if (filelength & 0xffff0000L)
         regs.r.bx.word = (filelength >> 16) & 0xffffL;
      close(filein);
      }
   }

void dispregs()  /* display registers and flags */
   {
   char hexout[6];

   PUTS("AX=");
   PUTS(hexword(&regs.r.ax.word,hexout));
   PUTS("  BX=");
   PUTS(hexword(&regs.r.bx.word,hexout));
   PUTS("  CX=");
   PUTS(hexword(&regs.r.cx.word,hexout));
   PUTS("  DX=");
   PUTS(hexword(&regs.r.dx.word,hexout));
   PUTS("  SP=");
   PUTS(hexword(&regs.r.sp,hexout));
   PUTS("  BP=");
   PUTS(hexword(&regs.r.bp,hexout));
   PUTS("  SI=");
   PUTS(hexword(&regs.r.si,hexout));
   PUTS("  DI=");
   PUTS(hexword(&regs.r.di,hexout));
   PUTS("\nDS=");  /* start of next line */
   PUTS(hexword(&regs.r.ds,hexout));
   PUTS("  ES=");
   PUTS(hexword(&regs.r.es,hexout));
   PUTS("  SS=");
   PUTS(hexword(&regs.r.ss,hexout));
   PUTS("  CS=");
   PUTS(hexword(&regs.r.cs,hexout));
   PUTS("  IP=");
   PUTS(hexword(&regs.r.ip,hexout));
   PUTS("   ");
   display_flags();
   PUTS(nl_str);
   }

void display_flags()
   {
   int i;

   for (i = 0; i < 9; i++)
      {
      if (regs.r.flag & flagmasks[i])
         PUTS(flagnames[1][i]);
      else
         PUTS(flagnames[0][i]);
      PUTS(space_str);
      }
   }

void modify_flags()
   {
   int i,valid;

   if (!parse(globalstr))
      {
      display_flags();
      getstr(" \n-",cmdline);
      cmdptr = 0;
      parse(globalstr);
      }
   valid = TRUE;
   while ((valid) && (globalstr[0]))
      {
      strupr(globalstr);
      valid = FALSE;  /* will be forced true by valid flag name */
      for (i = 0; i < 9; i++)
         {
         if (strcmp(globalstr,flagnames[0][i]) == 0)
            {
            valid = TRUE;
            regs.r.flag &= ~flagmasks[i];
            }
         if (strcmp(globalstr,flagnames[1][i]) == 0)
            {
            valid = TRUE;
            regs.r.flag |= flagmasks[i];
            }
         }
      parse(globalstr);
      }
   if (valid == FALSE)
      oops("flag? \n");
   }

int gchar()
      /* DeSmet and MS-DOS specific, test keyboard and return 256 (to
         identify byte (char) in al as not significant) if no key hit,
         else char.  Note that 0 return means 1st keycode of a function
         key.
      */
   {
#asm
   mov ah,1        ;test for key waiting
   int 16h         ;call BIOS
   jz  gchar1      ;if no character, flag it
   mov ah,0        ;get keyboard character
   int 16h         ;call BIOS
   or al,al        ;extended key?
   jnz gchar3      ;no, skip this
   xchg al,ah      ;set al = scancode
gchar3:
   mov ah,0        ;char = AL
   jmp gchar2      ;skip flagging
gchar1: mov ah,1   ;tell of no character
gchar2: 
#endasm
   }

void setmchnvectors(fnptr,base)  /* set the system vectors to point to VIM */
   unsigned int fnptr,base;
   {
   POKE((fnptr & 0xff),0,base);
   POKE( ((fnptr >> 8) & 0xff),0,base+1);
   POKE((codesegment & 0xff),0,base+2);
   POKE( ((codesegment >> 8) & 0xff),0,base+3);
   }

void setcsvectors(holder,base)  /* put the system vector in the work area
                                   for this interrupt handler */
   struct intrptr *holder;
   unsigned int base;
   {
/*   POKE((holder->ptrofs & 0xff),codesegment,base);
   POKE( ((holder->ptrofs >> 8) & 0xff),codesegment,base+1);
   POKE((holder->ptrseg & 0xff),codesegment,base+2);
   POKE( ((holder->ptrseg >> 8) & 0xff),codesegment,base+3); */
   }

void setvectors()  /* Set interrupt pointers for simulator use
                      There is a lot of machine/compiler specifics here.  */
   {
   void (*func)();  /* declare a pointer to a function.  I prefer to reference
                       things through this pointer than directly through
                       the function name. */
   void int8hdlr(),int9hdlr(),intahdlr(),intbhdlr(),intchdlr(),intdhdlr(),
        intehdlr(),intfhdlr(),
        int70hdlr(),int71hdlr(),int72hdlr(),int73hdlr(),int74hdlr(),
        int75hdlr(),int76hdlr(),int77hdlr();
               /* declare functions so we can set pointers to them. */

   /* disable interrupts while vectors are being changed */
#asm
   cli    ;NO INTERUPTS!  INLINE ASSEMBLER IS COMPILER SPECIFIC!
#endasm
   func = int8hdlr;  /* set up for Int 8 handler */
   setmchnvectors(func,0x20);
   setcsvectors(&int8ptr,0x0b);

   func = int9hdlr;  /* set up for Int 9 handler */
   setmchnvectors(func,0x24);
   setcsvectors(&int9ptr,0x0f);

   func = intahdlr;  /* set up for Int 0x0A handler */
   setmchnvectors(func,0x28);
   setcsvectors(&intaptr,0x13);

   func = intbhdlr;  /* set up for Int 0x0B handler */
   setmchnvectors(func,0x2c);
   setcsvectors(&intbptr,0x17);

   func = intchdlr;  /* set up for Int 0x0C handler */
   setmchnvectors(func,0x30);
   setcsvectors(&intcptr,0x1b);

   func = intdhdlr;  /* set up for Int 0x0D handler */
   setmchnvectors(func,0x34);
   setcsvectors(&intdptr,0x1f);

   func = intehdlr;  /* set up for Int 0x0E handler */
   setmchnvectors(func,0x38);
   setcsvectors(&inteptr,0x23);

   func = intfhdlr;  /* set up for Int 0x0F handler */
   setmchnvectors(func,0x3c);
   setcsvectors(&intfptr,0x27);

   func = int70hdlr;  /* set up for Int 0x70 handler */
   setmchnvectors(func,0x1c0);
   setcsvectors(&int70ptr,0x2b);

   func = int71hdlr;  /* set up for Int 0x71 handler */
   setmchnvectors(func,0x1c4);
   setcsvectors(&int71ptr,0x2f);

   func = int72hdlr;  /* set up for Int 0x72 handler */
   setmchnvectors(func,0x1c8);
   setcsvectors(&int72ptr,0x33);

   func = int73hdlr;  /* set up for Int 0x73 handler */
   setmchnvectors(func,0x1cc);
   setcsvectors(&int73ptr,0x37);

   func = int74hdlr;  /* set up for Int 0x74 handler */
   setmchnvectors(func,0x1d0);
   setcsvectors(&int74ptr,0x3b);

   func = int75hdlr;  /* set up for Int 0x75 handler */
   setmchnvectors(func,0x1d4);
   setcsvectors(&int75ptr,0x3f);

   func = int76hdlr;  /* set up for Int 0x76 handler */
   setmchnvectors(func,0x1d8);
   setcsvectors(&int76ptr,0x43);

   func = int77hdlr;  /* set up for Int 0x77 handler */
   setmchnvectors(func,0x1dc);
   setcsvectors(&int77ptr,0x47);

/* IMPORTANT: Turn interrupts back on */
#asm
   sti   ;Interrupts OK now.  INLINE ASSEMBLER IS COMPILER SPECIFIC!
#endasm
   }

void resetmchnvectors(holder,base)  /* replace the system vector in the
                                       interrupt pointer area */
   struct intrptr *holder;
   unsigned int base;
   {
   POKE((holder->ptrofs & 0xff),0,base);
   POKE( ((holder->ptrofs >> 8) & 0xff),0,base+1);
   POKE((holder->ptrseg & 0xff),0,base+2);
   POKE( ((holder->ptrseg >> 8) & 0xff),0,base+3);
   }

void resetvectors()
   {
/* Restore the interrupt vectors.  This routine contains machine/compiler
   specific code. */
#asm
    ;NOTE:  TURN OFF INTERRUPTS WHEN CHANGING INTERRUPT VECTORS!
    ;       Of course, inline assembler is both compiler and machine specific
    cli   ;interrupts OFF!
#endasm
   resetmchnvectors(&int8ptr,0x20);
   resetmchnvectors(&int9ptr,0x24);
   resetmchnvectors(&intaptr,0x28);
   resetmchnvectors(&intbptr,0x2c);
   resetmchnvectors(&intcptr,0x30);
   resetmchnvectors(&intdptr,0x34);
   resetmchnvectors(&inteptr,0x38);
   resetmchnvectors(&intfptr,0x3c);
   resetmchnvectors(&int70ptr,0x1c0);
   resetmchnvectors(&int71ptr,0x1c4);
   resetmchnvectors(&int72ptr,0x1c8);
   resetmchnvectors(&int73ptr,0x1cc);
   resetmchnvectors(&int74ptr,0x1d0);
   resetmchnvectors(&int75ptr,0x1d4);
   resetmchnvectors(&int76ptr,0x1d8);
   resetmchnvectors(&int77ptr,0x1dc);
#asm
   ;IMPORTANT - SET INTERRUPTS (ENABLE INTERRUPTS) BEFORE LEAVING ROUTINE!
   ;       This is, of course, machine and compiler specific
   sti    ;set interrupt flag again
#endasm
   }

void checkaddress2(seg,ofs)
   unsigned int *seg, *ofs;
   {
   UNSIGNED_LONG temp;
   unsigned int t1,aseg,count;

   aseg = (t1 = *seg + (*ofs >> 4)) >> 12;
   temp = (((UNSIGNED_LONG)t1) << 4) + (*ofs & 0x000f);
   if (numbreaks)
      {
      for (count = 1; count <= numbreaks; count++)
         if ((temp >= brkpoints[count].lowaddr)
                   && (temp <= brkpoints[count].highaddr))
           if (--brkcounts[count] == 0)
              memok = FALSE;
      }
   if ((temp >= min_screen) && (temp <= max_screen))
      {
      *seg = datasegment;
      *ofs = &screen[(int)(temp-min_screen)];  /* ignore the warning */
      }
   else
      *seg += memmap[aseg];
   }

void checkwaddress2(seg1,ofs1,seg2,ofs2)
   unsigned int *seg1, *ofs1, *seg2, *ofs2;
   {
   UNSIGNED_LONG temp,temp2;
   unsigned int t1,t2,aseg1,aseg2,count;

   aseg1 = (t1 = *seg1 + (*ofs1 >> 4)) >> 12;
   aseg2 = (t2 = *seg2 + (*ofs2 >> 4)) >> 12;
   temp = (((UNSIGNED_LONG)t1) << 4) + (*ofs1 & 0x000f);
   temp2 = (((UNSIGNED_LONG)t2) << 4) + (*ofs2 & 0x000f);
   if (numbreaks)
      {
      for (count = 1; count <= numbreaks; count++)
         {
         if ((temp >= brkpoints[count].lowaddr)
                   && (temp <= brkpoints[count].highaddr))
           if (--brkcounts[count] == 0)
              memok = FALSE;
         if ((temp2 >= brkpoints[count].lowaddr)
                           && (temp2 <= brkpoints[count].highaddr))
            if (--brkcounts[count] == 0)
               memok = FALSE;
         }
      }
   if ((temp >= min_screen) && (temp <= max_screen))
      {
      *seg1 = datasegment;
      *ofs1 = &screen[(int)(temp-min_screen)];  /* ignore the warning */
      }
   else
      *seg1 += memmap[aseg1];
   if ((temp2 >= min_screen) && (temp2 <= max_screen))
      {
      *seg2 = datasegment;
      *ofs2 = &screen[(int)(temp2-min_screen)];  /* ignore the warning */
      }
   else
      *seg2 += memmap[aseg2];
   }

getpage()   /* for ZF command */
   {
   int numin,i,j,count;

   lseek(zf_file,zf_pos,0);
   if ((numin = read(zf_file,zf_screen,1840)) == 0)
      return(numin);             /* 1840 = 23 * 80 */
   for (i = 0, j = 0, count = 0; i < numin; i++)
      {
      j = (zf_screen[i] == '\t') ? j - j%8 + 8 : j+1;
      if ((zf_screen[i] == '\012') || (j == 80))
         {
         if ((j != 80) || (zf_screen[i+1] != '\012'))
            if (++count == 23)
               break;
         j = 0;
         }
      }
   zf_pos += zf_screen[i] == '\012' ? i+1 : i;
   zf_screen[i] = '\0';
   return(numin);  /* show if EOF or not */
   }

pageup(again)   /* for ZF command */
   int again;
   {
   int numin,i,j,count,num;

   num = zf_pos > 1840L ? 1840 : (int)zf_pos;
   lseek(zf_file,zf_pos-(long)num,0);
   numin = read(zf_file,zf_screen,num);
   for (i = numin, j = 0, count = 0; i > 0; i--, zf_pos--)
      {
      j = zf_screen[i] == '\t' ? j - j%8 + 8 : j+1;
      if ((zf_screen[i] == '\012') || (j == 80))
         {
         if ((j != 80) || (zf_screen[i-1] != '\012'))
            if (++count == 24)
               {
               if (zf_screen[i] == '\012')
                  zf_pos++;
               break;
               }
         j = 0;
         }
      }
   if ((again) && (zf_pos))
      pageup(FALSE);  /* at start of this page, back up again */
   }

showpage()   /* for ZF command */
   {
   getpage();
   clrscr(24);
   curpos(0,0);
   PUTS(zf_header);
   PUTS(zf_screen);
   }

findstring(to_find,in_this_string)
   char *to_find;
   char *in_this_string;
   {
   int i,j,k,l;

   j = -1;
   k = strlen(to_find);
   l = strlen(in_this_string);
   if (k <= l)
      for (i = 0; (i <= l-k) && (j == -1); i++)
         if (strncmp(&in_this_string[i],to_find,k) == 0)
            j = i;
   return(j);
   }

int find_first()
   {
   int return_val;

   return_val = 0;
#asm
   mov ah,2fh            ;fn = get DTA
   int 21h               ;call DOS
   mov word ptr [dta_ofs_],bx  ;save old DTA offset
   mov word ptr [dta_seg_],es  ;save old DTA segment
   push ds               ;copy DS
   pop es                ;to ES
   mov dx,offset zf_screen_ ;DS:DX = new DTA
   mov ah,1ah            ;fn = set DTA
   int 21h               ;call DOS
   mov dx,offset tempstr_ ;DS:DX = wild card filename
   mov cx,17h            ;attribute = ALL
   mov ah,4eh            ;fn = find first
   int 21h               ;call DOS
   jae f_f_1             ;JNC f_f_1
   mov word ptr [bp-2],ax    ;else save error
f_f_1:
   mov dx,word ptr [dta_ofs_]  ;get old DTA offset
   mov ds,word ptr [dta_seg_]  ;get old DTA segment
   mov ah,1ah            ;fn = set DTA
   int 21h               ;call DOS
   push es               ;copy ES
   pop ds                ;to DS
#endasm
   return(return_val);
   }

int find_next()
   {
   int return_val;

   return_val = 0;
#asm
   mov ah,2fh            ;fn = get DTA
   int 21h               ;call DOS
   mov word ptr [dta_ofs_],bx  ;save old DTA offset
   mov word ptr [dta_seg_],es  ;save old DTA segment
   push ds               ;copy DS
   pop es                ;to ES
   mov dx,offset zf_screen_ ;DS:DX = new DTA
   mov ah,1ah            ;fn = set DTA
   int 21h               ;call DOS
   mov ah,4fh            ;fn = find next
   int 21h               ;call DOS
   jae f_n_1             ;JNC f_n_1
   mov word ptr [bp-2],ax    ;else save error
f_n_1:
   mov dx,word ptr [dta_ofs_]  ;get old DTA offset
   mov ds,word ptr [dta_seg_]  ;get old DTA segment
   mov ah,1ah            ;fn = set DTA
   int 21h               ;call DOS
   push es               ;copy ES
   pop ds                ;to DS
#endasm
   return(return_val);
   }

changedir(to,save)
   char *to, *save;
   {
   int return_val;

   return_val = 0;
#asm
   push ds                 ;copy ds
   pop es                  ;to es
   mov si,word ptr [bp+4]  ;si = to
   mov di,word ptr [bp+6]  ;di = save
   cld                     ;up!
   cmp byte ptr [si+1],':' ;drive specified?
   jne changedir_nodrive   ;no, skip this
   mov ah,19h              ;fn = get current disk
   int 21h                 ;call DOS
   add al,'A'              ;change to letter
   stosb                   ;put in dest string
   mov al,':'              ;a colon, designate drive
   stosb                   ;put in dest string
changedir_nodrive:
   mov al,'\'              ;backslash, needed in path
   stosb                   ;put in dest string
   xchg di,si              ;need si = dest string
   mov dl,0                ;default drive
   mov ah,47h              ;fn = get current dir
   int 21h                 ;call DOS
   xchg si,di              ;di = dest string again
   cmp byte ptr [si+1],':' ;once again, a drive?
   jne changedir_nodrive_2 ;no, skip this
   lodsb                   ;get drive letter
   and al,1fh              ;get drive number
   dec al                  ;A=0, B=1, etc
   mov dl,al               ;set drive for DOS
   mov ah,0eh              ;fn = set drive
   int 21h                 ;call DOS
   mov ah,19h              ;fn = get drive
   int 21h                 ;call DOS
   cmp al,dl               ;drive set OK?
   jne changedir_bad       ;no, skip this
   lodsb                   ;skip the ':' in the source
changedir_nodrive_2:
   mov dx,si               ;use DX for DOS
   lodsb                   ;get first byte of pathname
   or al,al                ;blank?
   je changedir_good       ;yes, don't call DOS
   mov ah,3bh              ;fn = set DIR
   int 21h                 ;call DOS
   jae changedir_good      ;all OK, skip this
changedir_bad:
   inc word ptr [bp-2]     ;flag error return
changedir_good:
#endasm
   return(return_val);
   }

getstr(prompt,target)
   char *prompt, *target;
   {
   PUTS(prompt);
   if (fileinput)
      {
      GETS(target);
      if (gchar() == ESC_KEY)
         target[0] = '\0';
      if (target[0])
         PUTS(target);
      else
         redirectinput("con",NO);  /* force console input */
      PUTS(nl_str);
      }
   else
      {
      GETS(target);
      if (outfile)
         {
         fileputs(target);
         fileputs(nl_str);
         }
      }
   }
