#include <compiler.h>
#include <vim.h>
#include <opdefs.h>
#include <asmstuff.h>
#include <include\ctype.h>

extern struct asminfo asmtable[113];
extern struct sameas equivops[21];
extern char opnames[113][7];  /* names of instructions, used for X command */
extern char regnames[23][3];

extern unsigned int asmip;
extern unsigned int asmcs;
extern unsigned int bytectr;
extern unsigned int asmspacing;
extern unsigned int cmdptr;
extern unsigned int valid;
extern unsigned char globalstr[150];
extern unsigned char cmdline[150];
extern unsigned char xname[160];
extern unsigned char space_str[2];
extern char tab[2];

struct srcdestinfo srcinfo,desinfo,tempinfo;

unsigned int byteword;
unsigned char rmtable[16] = {6,7,6,8,4,0,2,8,5,1,3,8,8,8,8,8};
unsigned char err_asm[10] = "operand?\n";

unsigned char *hexword();

void swapsrcdest(),code_offset();

int vimasm()
   {
   int i,which;
   UNSIGNED_LONG value;

   srcinfo.value.word = 0;  /* clear leftover high bytes */
   desinfo.value.word = 0;
   srcinfo.mod = 0;
   desinfo.mod = 0;
   srcinfo.eabyte = 0;
   desinfo.eabyte = 0;
   byteword = 0;  /* clear byte/word flags, too */
   bytectr = 0;
   valid = TRUE;
   parse(globalstr);
   which = -1;
   strupr(globalstr);
   if (cmdline[cmdptr] == ':')  /* for CS:, ES:, DS:, SS: */
      {
      strcat(globalstr,":");
      cmdptr++;
      }
   for (i = 0; i < 113; i++)
      if (strcmp(opnames[i],globalstr) == 0)
         which = i;
   if (which == -1)
      for (i = 0; i < 21; i++)
         if (strcmp(equivops[i].name,globalstr) == 0)
            which = equivops[i].code;
   if ((which == -1) || (asmtable[which].flags == A_UNDEF))
      if (globalstr[0] != ';')
         oops("opcode?\n");
      else
         valid = FALSE;
   else
      {
      xname[bytectr] = asmtable[which].firstbyte;
      switch (asmtable[which].flags)
         {
         case A_AADAAM:
            xname[++bytectr] = 0x0a;
            break;
         case A_MATH:
            if ((mathif() && (desinfo.datatype != SEGREG)
                 && (srcinfo.datatype != SEGREG)))
               {
               if ((xname[bytectr] == 0x84)
                    && (srcinfo.datatype != DATA16))
                  swapsrcdest();
               if (srcinfo.datatype == DATA16)
                  if ((desinfo.datatype == MEMREF) && (desinfo.mod == 192)
                          && (desinfo.eabyte == 0))
                     {
                     xname[bytectr] += (xname[bytectr] == 0x84 ? 0x24:4);
                     xname[++bytectr] = srcinfo.value.byte.low;
                     }
                  else
                     if ((desinfo.datatype == REG) && (desinfo.eabyte == 0))
                        {
                        xname[bytectr] += (xname[bytectr] == 0x84 ? 0x25:5);
                        xname[++bytectr] = srcinfo.value.byte.low;
                        xname[++bytectr] = srcinfo.value.byte.high;
                        }
                     else
                        {
                        xname[bytectr] = asmtable[which].eabase;
                        i = bytectr;
                        xname[++bytectr] = desinfo.mod | desinfo.eabyte
                                            | (asmtable[which].reg << 3);
                        code_offset(&desinfo);
                        xname[++bytectr] = srcinfo.value.byte.low;
                        if (byteword == WORD)
                           {
                           if ((((srcinfo.value.word & 0xff80L) == 0xff80L)
                                 || ((srcinfo.value.word & 0xff80L) == 0L))
                                 && (xname[i] != 0xf6))
                              xname[i] += 2;
                           else
                              xname[++bytectr] = srcinfo.value.byte.high;
                           xname[i]++;
                           }
                        }
               else
                  {
                  if (byteword == WORD)
                     xname[bytectr]++;
                  if ((srcinfo.datatype == MEMREF) && (srcinfo.mod != 192))
                     {
                     if ((xname[bytectr] & 0xfe) != 0x84)
                        xname[bytectr] += 2;
                     xname[++bytectr] = srcinfo.mod | srcinfo.eabyte
                                           | (desinfo.eabyte << 3);
                     code_offset(&srcinfo);
                     }
                  else
                     {
                     xname[++bytectr] = desinfo.mod | desinfo.eabyte
                                           | (srcinfo.eabyte << 3);
                     code_offset(&desinfo);
                     }
                  }
               }
            else
               oops(err_asm);
            break;
         case A_CALLJMP:
            if ((getarg(&desinfo))
                 && (desinfo.datatype != SEGREG)
                 && (desinfo.datatype != FARPTR)
                 && ((byteword == 0) || (byteword == WORD)))
               if (desinfo.datatype == DATA16)
                  if ((xname[bytectr] == 0xe9) && ((asmip-(unsigned int)desinfo.value.word <= 126)
                         || ((unsigned int)desinfo.value.word-asmip <= 129)))
                     {
                     xname[bytectr] += 2;
                     xname[++bytectr] = desinfo.value.word - (asmip + 2);
                     }
                  else
                     {
                     xname[++bytectr] = desinfo.value.word - (asmip + 3);
                     xname[++bytectr] = ((desinfo.value.word - (asmip + 3)) & 0xff00) >> 8;
                     }
               else
                  {
                  xname[bytectr] = asmtable[which].eabase;
                  xname[++bytectr] = desinfo.mod | desinfo.eabyte
                                       | (asmtable[which].reg << 3);
                  code_offset(&desinfo);
                  }
            else
               oops(err_asm);
            break;
         case A_FARCALL:
            if ((getarg(&desinfo))
               && (((desinfo.datatype == MEMREF) && (desinfo.mod < 192))
                     || (desinfo.datatype == FARPTR)))
                  if (desinfo.datatype == MEMREF)
                     {
                     xname[bytectr] = asmtable[which].eabase;
                     xname[++bytectr] = desinfo.eabyte | desinfo.mod
                                          | (asmtable[which].reg << 3);
                     code_offset(&desinfo);
                     }
                  else
                     {
                     xname[++bytectr] = desinfo.value.byte.low;
                     xname[++bytectr] = desinfo.value.byte.high;
                     xname[++bytectr] = desinfo.value.byte.low2;
                     xname[++bytectr] = desinfo.value.byte.high2;
                     }
            else
               oops(err_asm);
            break;
         case A_INCDEC:
            if ((getarg(&desinfo)) && (byteword))
               if (desinfo.datatype == REG)
                  xname[bytectr] += desinfo.eabyte;
               else
                  if (desinfo.datatype == MEMREF)
                     {
                     xname[bytectr] = asmtable[which].eabase;
                     if (byteword == WORD)
                        xname[bytectr]++;
                     xname[++bytectr] = desinfo.eabyte | desinfo.mod
                                          | (asmtable[which].reg << 3);
                     code_offset(&desinfo);
                     }
                  else
                     oops(err_asm);
            else
               oops(err_asm);
            break;
         case A_MULDIV:
            if ((getarg(&desinfo))
                 && (((desinfo.datatype == REG) || (desinfo.datatype == MEMREF))
                      && (byteword)))
               {
               i = cmdptr;  /* set up for "unparsing" */
               if ((asmtable[which].reg == 5) && (desinfo.datatype == REG)
                    && (getarg(&srcinfo)) && ((srcinfo.datatype == REG)
                       || ((srcinfo.datatype == MEMREF) && (srcinfo.mod != 192)))
                   && (getarg(&tempinfo)) && (tempinfo.datatype == DATA16))
                  {
                  xname[bytectr] = 0x6b;
                  i = bytectr;
                  xname[++bytectr] = srcinfo.mod | srcinfo.eabyte
                                     | (desinfo.eabyte << 3);
                  code_offset(&srcinfo);
                  xname[++bytectr] = tempinfo.value.byte.low;
                  if (((tempinfo.value.word & 0xff80) != 0xff80)
                        && ((tempinfo.value.word & 0xff80) != 0))
                     {
                     xname[i] -= 2;
                     xname[++bytectr] = tempinfo.value.byte.high;
                     }
                  }
               else
                  {
                  cmdptr = i;
                  if (byteword == WORD)
                     xname[bytectr]++;
                  xname[++bytectr] = desinfo.eabyte | desinfo.mod |
                                       (asmtable[which].reg << 3);
                  code_offset(&desinfo);
                  }
               }
            else
               oops(err_asm);
            break;
         case A_INOUT:
            if (xname[bytectr] == 0xe4)
               valid = (getarg(&desinfo) && (getarg(&srcinfo)));
            else
               valid = (getarg(&srcinfo) && (getarg(&desinfo)));
            if ((valid)
                  && (((desinfo.datatype == REG) && (desinfo.eabyte == 0))
                        || ((desinfo.datatype == MEMREF) && (desinfo.mod == 192)
                                    && (desinfo.eabyte == 0)))
                  && (((srcinfo.datatype == REG) && (srcinfo.eabyte == 2))
                        || ((srcinfo.datatype == DATA16)
                                   && (srcinfo.value.word < 0x100))))
               {
               if (desinfo.datatype == REG)
                  xname[bytectr]++;
               if (srcinfo.datatype == REG)
                  xname[bytectr] += 8;
               else
                  xname[++bytectr] = srcinfo.value.byte.low;
               }
            else
               oops(err_asm);
            break;
         case A_INT:
            if ((getarg(&desinfo))
                 && (desinfo.datatype == DATA16)
                 && (desinfo.value.word < 0x100))
               if (desinfo.value.byte.low == 3)
                  xname[bytectr]--;
               else
                  xname[++bytectr] = desinfo.value.byte.low;
            else
               oops(err_asm);
            break;
         case A_JMPSHRT:
            if ((getarg(&desinfo))
                 && (desinfo.datatype == DATA16)
                 && ((asmip-(unsigned int)desinfo.value.word <= 126)
                         || ((unsigned int)desinfo.value.word-asmip <= 129)))
               xname[++bytectr] = desinfo.value.word - (asmip + 2);
            else
               oops(err_asm);
            break;
         case A_LOADER:
            if ((getarg(&desinfo))
                 && (desinfo.datatype == REG)
                 && (getarg(&srcinfo))
                 && ((srcinfo.datatype == MEMREF) && (srcinfo.mod != 192)))
               {
               xname[++bytectr] = srcinfo.mod | srcinfo.eabyte
                                  | (desinfo.eabyte << 3);
               code_offset(&srcinfo);
               }
            else
               oops(err_asm);
            break;
         case A_MOV:
            if ((mathif())
                 && ((desinfo.datatype != SEGREG) || (srcinfo.datatype != SEGREG))
                 && ((desinfo.datatype != SEGREG) || (srcinfo.datatype != DATA16)))
               {
               if ((desinfo.datatype == REG) && (srcinfo.datatype == DATA16))
                  {
                  xname[bytectr] += 8 + desinfo.eabyte;
                  xname[++bytectr] = srcinfo.value.byte.low;
                  xname[++bytectr] = srcinfo.value.byte.high;
                  }
               else
                  if ((desinfo.datatype == MEMREF) && (desinfo.mod == 192)
                       && (srcinfo.datatype == DATA16)
                        && (srcinfo.value.word < 0x100))
                     {
                     xname[bytectr] += desinfo.eabyte;
                     xname[++bytectr] = srcinfo.value.byte.low;
                     }
                  else
                     {
                     if ((desinfo.datatype == MEMREF) && (desinfo.mod == 0)
                          && (desinfo.eabyte == 6) && (srcinfo.eabyte == 0)
                          && ((srcinfo.datatype == REG)
                               || ((srcinfo.datatype == MEMREF)
                                    && (srcinfo.mod == 192))))
                        {
                        swapsrcdest();
                        xname[bytectr] += 2;
                        }
                     if ((srcinfo.datatype == MEMREF) && (srcinfo.mod == 0)
                          && (srcinfo.eabyte == 6) && (desinfo.eabyte == 0)
                          && ((desinfo.datatype == REG)
                               || ((desinfo.datatype == MEMREF)
                                    && (desinfo.mod == 192))))
                        {
                        xname[bytectr] -= 0x10;
                        if (desinfo.datatype == REG)
                           xname[bytectr]++;
                        xname[++bytectr] = srcinfo.value.byte.low;
                        xname[++bytectr] = srcinfo.value.byte.high;
                        }
                     else
                        if (srcinfo.datatype == DATA16)
                           {
                           xname[bytectr] = (byteword == WORD? 0xc7 : 0xc6);
                           xname[++bytectr] = desinfo.mod | desinfo.eabyte;
                           code_offset(&desinfo);
                           xname[++bytectr] = srcinfo.value.byte.low;
                           if (byteword == WORD)
                              xname[++bytectr] = srcinfo.value.byte.high;
                           }
                        else
                           if (desinfo.datatype == SEGREG)
                              {
                              xname[bytectr] = 0x8e;
                              xname[++bytectr] = srcinfo.mod | srcinfo.eabyte
                                                   | ((desinfo.eabyte-8) << 3);
                              code_offset(&srcinfo);
                              }
                           else
                              if (srcinfo.datatype == SEGREG)
                                 {
                                 xname[bytectr] = 0x8c;
                                 xname[++bytectr] = desinfo.mod | desinfo.eabyte
                                               | ((srcinfo.eabyte-8) << 3);
                                 code_offset(&desinfo);
                                 }
                              else
                                 {
                                 xname[bytectr] = 0x88;
                                 if (byteword == WORD)
                                    xname[bytectr]++;
                                 if ((srcinfo.datatype == MEMREF)
                                      && (srcinfo.mod != 192))
                                    {
                                    xname[bytectr] += 2;
                                    xname[++bytectr] = srcinfo.mod | srcinfo.eabyte
                                            | (desinfo.eabyte << 3);
                                    code_offset(&srcinfo);
                                    }
                                 else
                                    {
                                    xname[++bytectr] = desinfo.mod | desinfo.eabyte
                                            | (srcinfo.eabyte << 3);
                                    code_offset(&desinfo);
                                    }
                                 }
                     }
               }
            else
               oops(err_asm);
            break;
         case A_PUSHPOP:
            if ((getarg(&desinfo))
                 && ((byteword == WORD) || (byteword == 0))
                 && ((desinfo.datatype != SEGREG) || (xname[bytectr] != 0x58)
                        || (desinfo.eabyte != 9)))
               if (desinfo.datatype == REG)
                  xname[bytectr] += desinfo.eabyte;
               else
                  if (desinfo.datatype == MEMREF)
                     {
                     xname[bytectr] = asmtable[which].eabase;
                     xname[++bytectr] = desinfo.mod | desinfo.eabyte
                                          | (asmtable[which].reg << 3);
                     code_offset(&desinfo);
                     }
                  else
                     if (desinfo.datatype == SEGREG)
                        xname[bytectr] = (xname[bytectr] == 0x58 ? 7:6)
                                           | ((desinfo.eabyte-8) << 3);
                     else
                        if ((desinfo.datatype == DATA16) && (xname[bytectr] == 0x50))
                           {
                           xname[bytectr] = 0x6a;
                           xname[++bytectr] = desinfo.value.byte.low;
                           if (((desinfo.value.word & 0xff80) != 0xff80)
                                 && ((desinfo.value.word & 0xff80) != 0))
                              {
                              xname[bytectr-1] -= 2;
                              xname[++bytectr] = desinfo.value.byte.high;
                              }
                           }
                        else
                           oops(err_asm);
            else
               oops(err_asm);
            break;
         case A_ROTSHF:
            if ((getarg(&desinfo))
                 && (byteword)
                 && ((desinfo.datatype == REG)
                      || (desinfo.datatype == MEMREF))
                 && (getarg(&srcinfo))
                 && (((srcinfo.datatype == DATA16) && (srcinfo.value.word < 0x100))
                       || ((srcinfo.datatype == MEMREF) && (srcinfo.mod == 192)
                       && (srcinfo.eabyte == 1))))
               {
               if (byteword & WORD)
                  xname[bytectr]++;
               if (srcinfo.datatype == DATA16)
                  if (srcinfo.value.byte.low == 1)
                     {
                     xname[++bytectr] = desinfo.mod | desinfo.eabyte
                                          | (asmtable[which].reg << 3);
                     code_offset(&desinfo);
                     }
                  else
                     {
                     xname[bytectr] -= 0x10;
                     xname[++bytectr] = desinfo.mod | desinfo.eabyte
                                          | (asmtable[which].reg << 3);
                     code_offset(&desinfo);
                     xname[++bytectr] = srcinfo.value.byte.low;
                     }
               else
                  {
                  xname[bytectr] += 2;
                  xname[++bytectr] = desinfo.mod | desinfo.eabyte
                                       | (asmtable[which].reg << 3);
                  code_offset(&desinfo);
                  }
               }
            else
               oops(err_asm);
            break;
         case A_RET:
            if (getarg(&desinfo))
               if (desinfo.datatype == DATA16)
                  {
                  xname[bytectr]--;
                  xname[++bytectr] = desinfo.value.byte.low;
                  xname[++bytectr] = desinfo.value.byte.high;
                  }
               else
                  oops(err_asm);
            break;
         case A_XCHG:
            if ((mathif()) && (desinfo.datatype != SEGREG) && (srcinfo.datatype != SEGREG)
                 && (srcinfo.datatype != DATA16))
               {
               if ((desinfo.datatype == MEMREF) && (desinfo.mod != 192))
                  swapsrcdest();
               if ((desinfo.datatype == REG) && (srcinfo.datatype == REG)
                    && (desinfo.eabyte == 0))
                  xname[bytectr] = 0x90 + srcinfo.eabyte;
               else
                  if ((desinfo.datatype == REG) && (srcinfo.datatype == REG)
                       && (srcinfo.eabyte == 0))
                          xname[bytectr] = 0x90 + desinfo.eabyte;
                  else
                     {
                     if (byteword == WORD)
                        xname[bytectr]++;
                     xname[++bytectr] = srcinfo.mod | srcinfo.eabyte
                                         | (desinfo.eabyte << 3);
                     code_offset(&srcinfo);
                     }
               }
            else
               oops(err_asm);
            break;
         case A_ENTER:
            if ((getarg(&desinfo))
                 && (desinfo.datatype == DATA16)
                 && (getarg(&srcinfo))
                 && (srcinfo.datatype == DATA16)
                 && (srcinfo.value.word < 0x100))
               {
               xname[++bytectr] = desinfo.value.byte.low;
               xname[++bytectr] = desinfo.value.byte.high;
               xname[++bytectr] = srcinfo.value.byte.low;
               }
            else
               oops(err_asm);
            break;
         case A_DB:
            bytectr--;
            which = (globalstr[1] == 'W' ? 1:0);
            if (parse(globalstr))
               do
                  {
                  if ((evalstr(globalstr,&value))
                       && ((which) || (value < 0x100)))
                     {
                     xname[++bytectr] = value & 0xff;
                     if (which)
                        xname[++bytectr] = ((value >> 8) & 0xff);
                     }
                  else
                     if (isfillenterstr(globalstr))
                        {
                        i = 1;
                        do
                           {
                           xname[++bytectr] = globalstr[i++];
                           } while (globalstr[i+1]);
                        }
                     else
                        oops(err_asm);
                  } while ((valid) && (parse(globalstr)));
            break;
         }
      if (valid)
         if (parse(globalstr))
            if (globalstr[0] != ';')
               oops("what?\n");
      }
   return(valid);
   }

int getarg(st)
   struct srcdestinfo *st;
   {
   int i,j,bw;
   unsigned int tableindex,offsetused,offsetvalue,basecount,indexcount;
   unsigned int strindex,tsindex;
   unsigned char tempstr[150];
   UNSIGNED_LONG value,value2;

   bw = 0;
   if (!parse(globalstr))
      return(FALSE);
   strupr(globalstr);
   if (strcmp(globalstr,"BYTE") == 0)
      bw |= BYTE;
   if (strcmp(globalstr,"WORD") == 0)
      bw |= WORD;
   byteword |= bw;
   if (bw)
      {
      if (!parse(globalstr))
         return(FALSE);
      strupr(globalstr);
      if (strcmp(globalstr,"PTR") == 0)
         {
         parse(globalstr);
         strupr(globalstr);
         }
      }
   if ((i=isregname(globalstr)) != -1)
      {
      st->datatype = REG;
      st->mod = 192;
      st->eabyte = i;
      byteword |= WORD;
      if (i < 8)
         return(TRUE);
      if (i < 12)
         {
         st->datatype = SEGREG;
         return(TRUE);
         }
      else
         return(FALSE);
      }
   j = -1;
   for (i = 15; i < 23; i++)  /* position in array regnames of AL .. BH */
      if (strcmp(globalstr,regnames[i]) == 0)
         j = i-15;
   if (j != -1)
      {
      st->datatype = MEMREF;
      st->mod = 192;
      st->eabyte = j;
      byteword |= BYTE;
      return(TRUE);
      }
   if (evalstr(globalstr,&value))
      {
      if (cmdline[cmdptr] == ':')
         if ((parse(globalstr)) && (evalstr(globalstr,&value2)))
                   /* if a FARPTR */
            {
            st->datatype = FARPTR;
            st->value.word = (value << 16) + value2;
            return(TRUE);
            }
         else
            return(FALSE);
      st->datatype = DATA16;
      st->value.word = value;
      return(TRUE);
      }
   if ((globalstr[0] == '[') && (globalstr[strlen(globalstr)-1] == ']'))
      {
      if (globalstr[1] == ']')
         return(FALSE);
      offsetused = FALSE;
      offsetvalue = 0;
      basecount = 0;
      indexcount = 0;
      tableindex = 0;
      tsindex = 0;
      if ((globalstr[1] != '+') && (globalstr[1] != '-'))
         {
         tempstr[0] = '+';
         tsindex = 1;
         }
      strindex = 1;
      do
         {
         do
            {
            tempstr[tsindex++] = globalstr[strindex++];
            } while ((globalstr[strindex] != '+')
                      && (globalstr[strindex] != '-')
                      && (globalstr[strindex] != ']'));
         tempstr[tsindex] = '\0';
         if ((i = isaddreg(&tempstr[1])) && (tempstr[0] == '+'))
            {
            if (i > 2)
               indexcount++;
            else
               basecount++;
            tableindex |= i;
            }
         else
            if (evalstr(tempstr,&value))
               {
               offsetused = TRUE;
               offsetvalue += value;
               }
            else
               return(FALSE);
         tsindex = 0;
         } while (globalstr[strindex] != ']');
      if ((basecount > 1) || (indexcount > 1))
         return(FALSE);
      st->datatype = MEMREF;
      if ((st->eabyte = rmtable[tableindex]) > 7)
         return(FALSE);
      if (tableindex == 2)
         offsetused = TRUE;
      st->value.word = offsetvalue;
      if (tableindex == 0)
         st->mod = 0;
      else
         if (offsetused)
            {
            st->mod = 128;
            if (((offsetvalue & 0xff80) == 0xff80) || ((offsetvalue & 0xff80) == 0))
               st->mod = 64;
            }
      return(TRUE);
      }
   return(FALSE);
   }

void code_offset(st)
   struct srcdestinfo *st;
   {
   if ((st->mod == 64) || (st->mod == 128)
         || ((st->mod == 0) && (st->eabyte == 6)))
      xname[++bytectr] = st->value.byte.low;
   if ((st->mod == 128) || ((st->mod == 0) && (st->eabyte == 6)))
      xname[++bytectr] = st->value.byte.high;
   }

int mathif()
   {
   if ((getarg(&desinfo))
        && (desinfo.datatype != FARPTR)
        && (desinfo.datatype != DATA16)
        && (getarg(&srcinfo))
        && ((byteword & (byteword-1)) == 0) && (byteword)
        && (srcinfo.datatype != FARPTR)
        && (((srcinfo.datatype != DATA16) || (byteword != BYTE)
                  || (srcinfo.value.word < 0x100)))
        && ((desinfo.datatype != MEMREF) || (desinfo.mod == 192)
             || (srcinfo.datatype != MEMREF) || (srcinfo.mod == 192)))
      return(TRUE);
   else
      return(FALSE);
   }
/*
int mathif()
   {
   if ((getarg(&desinfo)) && (getarg(&srcinfo))
                 && ((byteword & (byteword-1)) == 0) && (byteword)
                 && (desinfo.datatype != FARPTR) && (srcinfo.datatype != FARPTR)
                 && (desinfo.datatype != DATA16)
                 && ((desinfo.datatype != MEMREF) || (desinfo.mod != 192)
                     || ((srcinfo.datatype != DATA16)
                           || (srcinfo.value.word < 0x100)))
                 && ((desinfo.datatype != MEMREF) || (desinfo.mod == 192)
                     || (srcinfo.datatype != MEMREF) || (srcinfo.mod == 192)))
      return(TRUE);
   else
      return(FALSE);
   }
*/

int isaddreg(name)  /* change name to upper case, and return the following:
                        0 = not an addressing register
                        1 = BX
                        2 = BP
                        4 = SI
                        8 = DI  */
   char *name;
   {
   char str[4];

   if (strlen(name) == 2)  /* if this could be a register name */
      {
      strcpy(str,name);
      strupr(str);
      if (strcmp(str,"BX") == 0)
         return(1);
      if (strcmp(str,"BP") == 0)
         return(2);
      if (strcmp(str,"SI") == 0)
         return(4);
      if (strcmp(str,"DI") == 0)
         return(8);
      }
   return(0);
   }

void swapsrcdest()
   {
   tempinfo = desinfo;
   desinfo = srcinfo;
   srcinfo = tempinfo;
   }

int evalstr(str,val)  /* change hex value in str to a number */
                     /* return FALSE if invalid hex number, else TRUE */
   unsigned char *str;
   UNSIGNED_LONG *val;  /* Beware of passing an INT pointer to this routine
                           if the machine does not use low-byte first! */
   {
   int i,valid,sign;
   unsigned int ch;

   i = 0;
   *val = 0;
   sign = FALSE;
   valid = FALSE;
   if ((str[0] == '-') || (str[0] == '+'))
      {
      if (str[0] == '-')
         sign = TRUE;
      i = 1;
      }
   ch = toupper(str[i++]);
   while (ch)
      {
      valid = TRUE;
      if (isdigit(ch))
         *val = (*val << 4) + ch - '0';  /* a number */
      else
         if ((ch >= 'A') && (ch <= 'F'))  /* a letter */
            *val = (*val << 4) + ch - 'A' + 10;
         else
            return(FALSE);
      ch = toupper(str[i++]);
      }
   if (sign)
      *val = -(*val);
   return(valid);
   }
